

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

public class EnumerateAllMotifOfSize8_5UTR {
	
	public EnumerateAllMotifOfSize8_5UTR(){
		
	}
	//Changed on 11/21/2014
	//public static void main(String[] args){
	public Pair<String,String> run(int _firstCharIndex, int _secondCharIndex, boolean _randomized, boolean _completeRandomized, String _inputProteinSeqFile){
		String outputMotifFilePath = "";
		String outputMotifTooManyGenesFilePath = "";
		try{
			//Changed on 11/21/2014
			/*int firstCharIndex = Integer.parseInt(args[0]);
			int secondCharIndex = Integer.parseInt(args[1]);
			boolean randomized = Boolean.parseBoolean(args[2]);
			boolean completeRandomized = Boolean.parseBoolean(args[3]);
			*/
			
			int firstCharIndex = _firstCharIndex;
			int secondCharIndex = _secondCharIndex;
			boolean randomized = _randomized;
			boolean completeRandomized = _completeRandomized;
			String inputProteinSeqFile = _inputProteinSeqFile;
			
			
			
			BufferedWriter out = null;
			BufferedWriter out2 = null;
			if(randomized){
				if(!completeRandomized){
					//Changed on 11/21/2014
					outputMotifFilePath = inputProteinSeqFile+"_AllMotifsFirstChar"+ firstCharIndex + "SecondChar" + secondCharIndex+"Randomized.txt";
					outputMotifTooManyGenesFilePath = inputProteinSeqFile+"_MotifsTooManyGenesFirstChar"+ firstCharIndex + "SecondChar" + secondCharIndex+"Randomized.txt";
					out = new BufferedWriter(new FileWriter(new File(outputMotifFilePath)));
					out2 = new BufferedWriter(new FileWriter(new File(outputMotifTooManyGenesFilePath)));
					//out = new BufferedWriter(new FileWriter(new File("data_noHub/AllMotifSize8_UTR5_FirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+"_GenomeBrowser_nohub_20Mar13_Randomized.txt")));
					//out2 = new BufferedWriter(new FileWriter(new File("data_noHub/MotifSize8_UTR5_WithTooManyGenes1500FirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+"_GenomeBrowser_nohub_20Mar13_Randomized.txt")));
				}
				else{
					//Changed on 11/21/2014
					outputMotifFilePath = inputProteinSeqFile+"_AllMotifsFirstChar"+ firstCharIndex + "SecondChar" + secondCharIndex+"CompletelyRandomized.txt";
					outputMotifTooManyGenesFilePath = inputProteinSeqFile+"_MotifsTooManyGenesFirstChar"+ firstCharIndex + "SecondChar" + secondCharIndex+"CompletelyRandomized.txt";
					out = new BufferedWriter(new FileWriter(new File(outputMotifFilePath)));
					out2 = new BufferedWriter(new FileWriter(new File(outputMotifTooManyGenesFilePath)));
					//out = new BufferedWriter(new FileWriter(new File("data_noHub/AllMotifSize8_UTR5_FirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+"_GenomeBrowser_nohub_20Mar13_CompletelyRandomized_Randomized.txt")));
					//out2 = new BufferedWriter(new FileWriter(new File("data_noHub/MotifSize8_UTR5_WithTooManyGenes1500FirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+"_GenomeBrowser_nohub_20Mar13_CompletelyRandomized_Randomized.txt")));
				}
			}
			else{
				//Changed on 11/21/2014
				outputMotifFilePath = inputProteinSeqFile+"_AllMotifsFirstChar"+ firstCharIndex + "SecondChar" + secondCharIndex+".txt";
				outputMotifTooManyGenesFilePath = inputProteinSeqFile+"_MotifsTooManyGenesFirstChar"+ firstCharIndex + "SecondChar" + secondCharIndex+".txt";
				out = new BufferedWriter(new FileWriter(new File(outputMotifFilePath)));
				out2 = new BufferedWriter(new FileWriter(new File(outputMotifTooManyGenesFilePath)));
				//out = new BufferedWriter(new FileWriter(new File("data_noHub/AllMotifSize8_UTR5_FirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+"_GenomeBrowser_nohub_20Mar13.txt")));
				//out2 = new BufferedWriter(new FileWriter(new File("data_noHub/MotifSize8_UTR5_WithTooManyGenes1500FirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+"_GenomeBrowser_nohub_20Mar13.txt")));
			}
			
			List<String> alpha = new ArrayList<String>();
			String a = "a";
			String c = "c";
			String g = "g";
			String t = "t";
			String r = "[ag]";
			String y = "[ct]";
			String dot = ".";
			alpha.add(0,a);
			alpha.add(1,c);
			alpha.add(2,g);
			alpha.add(3,t);
			alpha.add(4,r);
			alpha.add(5,y);
			alpha.add(6,dot);
			
			List<String> motifs = new ArrayList<String>();
			List<String> motifsToPrint = new ArrayList<String>();
			System.out.println("Creating Motifs...");
			String ToPrint1 = "";
			String ToPrint2 = "";
			String ToPrint3 = "";
			String ToPrint4 = "";
			String ToPrint5 = "";
			String ToPrint6 = "";
			String ToPrint7 = "";
			String ToPrint8 = "";
			for(int i = firstCharIndex; i < firstCharIndex+1; i++){
				if(i == 4){
					ToPrint1 = "r";
				}
				else if(i == 5){
					ToPrint1 = "y";
				}
				else if(i == 6){
					ToPrint1 = "n";
				}
				else{
					ToPrint1 = alpha.get(i);
				}
				for(int i2 = secondCharIndex; i2 < secondCharIndex+1; i2++){
					System.out.println(i2);
					if(i2 == 4){
						ToPrint2 = "r";
					}
					else if(i2 == 5){
						ToPrint2 = "y";
					}
					else if(i2 == 6){
						ToPrint2 = "n";
					}
					else{
						ToPrint2 = alpha.get(i2);
					}
					for(int i3 = 0; i3 < 7; i3++){
						if(i3 == 4){
							ToPrint3 = "r";
						}
						else if(i3 == 5){
							ToPrint3 = "y";
						}
						else if(i3 == 6){
							ToPrint3 = "n";
						}
						else{
							ToPrint3 = alpha.get(i3);
						}
						for(int i4 = 0; i4 < 7; i4++){
							if(i4 == 4){
								ToPrint4 = "r";
							}
							else if(i4 == 5){
								ToPrint4 = "y";
							}
							else if(i4 == 6){
								ToPrint4 = "n";
							}
							else{
								ToPrint4 = alpha.get(i4);
							}
							for(int i5 = 0; i5 < 7; i5++){
								if(i5 == 4){
									ToPrint5 = "r";
								}
								else if(i5 == 5){
									ToPrint5 = "y";
								}
								else if(i5 == 6){
									ToPrint5 = "n";
								}
								else{
									ToPrint5 = alpha.get(i5);
								}
								for(int i6 = 0; i6 < 7; i6++){
									if(i6 == 4){
										ToPrint6 = "r";
									}
									else if(i6 == 5){
										ToPrint6 = "y";
									}
									else if(i6 == 6){
										ToPrint6 = "n";
									}
									else{
										ToPrint6 = alpha.get(i6);
									}
									for(int i7 = 0; i7 < 7; i7++){
										if(i7 == 4){
											ToPrint7 = "r";
										}
										else if(i7 == 5){
											ToPrint7 = "y";
										}
										else if(i7 == 6){
											ToPrint7 = "n";
										}
										else{
											ToPrint7 = alpha.get(i7);
										}
										for(int i8 = 0; i8 < 7; i8++){
											if(i8 == 4){
												ToPrint8 = "r";
											}
											else if(i8 == 5){
												ToPrint8 = "y";
											}
											else if(i8 == 6){
												ToPrint8 = "n";
											}
											else{
												ToPrint8 = alpha.get(i8);
											}
											motifsToPrint.add(ToPrint1 + ToPrint2 + ToPrint3 + ToPrint4 + ToPrint5 + ToPrint6 + ToPrint7 + ToPrint8);
											motifs.add(".*"+alpha.get(i)+alpha.get(i2)+alpha.get(i3)+alpha.get(i4)+alpha.get(i5)+alpha.get(i6)+alpha.get(i7)+alpha.get(i8)+"(.*)");
											//out.flush();
										}
									}
								}
							}
						}
					}
				}
			}
			//out.close();
			System.out.println("Done Creating Motifs");
			BufferedReader in = null;
			
			in = new BufferedReader(new FileReader(new File(inputProteinSeqFile)));
			//Changed on 11/21/2014
			/*if(randomized){
				if(!completeRandomized){
					in = new BufferedReader(new FileReader(new File("data_noHub/ProteinsInConnectedNetWorkWithSeqsBiogrid28Feb13_5'UTR_GenomeBrowser_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_nohub_20Mar13_Randomized.txt")));
				}
				else{
					in = new BufferedReader(new FileReader(new File("data_noHub/ProteinsInConnectedNetWorkWithSeqsBiogrid28Feb13_5'UTR_GenomeBrowser_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_nohub_20Mar13_CompletelyRandomized_Randomized.txt")));
				}
			}
			else{
				in = new BufferedReader(new FileReader(new File("data_noHub/ProteinsInConnectedNetWorkWithSeqsBiogrid28Feb13_5'UTR_GenomeBrowser_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_nohub_20Mar13.txt")));
			}*/
			
			System.out.println("Associating Motifs With Sequences");
			List<List<String>> seqLists = new ArrayList<List<String>>();
			String s = in.readLine();
			while(s!=null){
				String[] split = s.split("\t");
				List<String> seqs = new ArrayList<String>();
				seqs.add(split[0]);
				int startSeqIndex = 0;
				if(randomized){
					startSeqIndex = 1;
				}
				else{
					startSeqIndex = (int)Math.ceil(((double)split.length/2.0));
				}
				for(int i = startSeqIndex; i < split.length; i++){
					if(split[i].length() <= 500){
						seqs.add(split[i]);
					}
					else{
						seqs.add(split[i].substring(0, 500));
					}
				}
				seqLists.add(seqs);
				s = in.readLine();
			}
			int counter = 0;
			List<String> motifWithTooManyGenes = new ArrayList<String>();
			for(int j = 0; j < motifs.size(); j++ ){
				int genesMatched = 0;
				counter++;
				//System.out.println(counter);
				String motif = motifs.get(j);
				String motifToPrint = motifsToPrint.get(j);
				out.write(motifsToPrint.get(j));
				for(List<String> seqs: seqLists){	
					for(int i = 1; i < seqs.size(); i++){
						if(seqs.get(i).matches(motif)){
							genesMatched++;
							out.write("\t" + seqs.get(0));
							out.flush();
							break;
						}
					}
				}
				if(genesMatched > 1500){
					motifWithTooManyGenes.add(motifToPrint);
					out.write("\n");
					out.flush();
					continue;
				}
				out.write("\n");
				out.flush();
			}
			out.close();
			for(String motif: motifWithTooManyGenes){
				out2.write(motif + "\n");
				out2.flush();
			}
			out2.close();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
		return new Pair<String,String>(outputMotifFilePath,outputMotifTooManyGenesFilePath);
	}
}
