
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Random;

public class MakeRandomDNA_UTRSequences {
	public static final String path = "data_noHub/";
	public static final int UTRtype = 5;

	public MakeRandomDNA_UTRSequences(){
		
	}
	
	//Changed on 11/21/2014
	public String run(String inputProteinSeqFile){
	//public static void main(String[] args){
		
		String outputProteinSeqFile = "";
		try{

			
			//Changed on 11/21/2014
			outputProteinSeqFile = inputProteinSeqFile+"_Randomized.txt";
			BufferedReader in = new BufferedReader(new FileReader(new File(inputProteinSeqFile)));
			BufferedWriter out = new BufferedWriter(new FileWriter(new File(outputProteinSeqFile)));
			//BufferedReader in = new BufferedReader(new FileReader(new File(path + "ProteinsInConnectedNetWorkWithSeqsBiogrid28Feb13_"+UTRtype+"'UTR_GenomeBrowser_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_nohub_20Mar13.txt")));
			//BufferedWriter out = new BufferedWriter(new FileWriter(new File(path + "ProteinsInConnectedNetWorkWithSeqsBiogrid28Feb13_"+UTRtype+"'UTR_GenomeBrowser_NoNonCodingRNAsNoHapNoSeqsAssociatedToMultProt_nohub_20Mar13_Randomized.txt")));
			
			
			//BufferedReader in = new BufferedReader(new FileReader(new File("ProteinsInNetWorkWithSeqsYeastBiogrid1000Upstream_20July2012.txt")));
			//BufferedWriter out = new BufferedWriter(new FileWriter(new File("ProteinsInNetWorkWithSeqsYeastBiogrid1000Upstream_Randomized_20July2012.txt")));
			//BufferedReader in = new BufferedReader(new FileReader(new File("src/src/ProteinsInNetWorkWithSeqsYeastBiogrid1000Upstream.txt")));
		//	BufferedReader in = new BufferedReader(new FileReader(new File("src/src/TestDNASeq.txt")));
			//BufferedWriter out = new BufferedWriter(new FileWriter(new File("src/src/ProteinsInNetWorkWithSeqsYeastBiogrid1000UpstreamRandomized.txt")));
		//	BufferedWriter out = new BufferedWriter(new FileWriter(new File("src/src/TestDNASeqRandomized")));
			String s = in.readLine();
			Random r = new Random();
			while(s != null){
				out.write(s.split("\t")[0]);
				for(int index = (int)Math.ceil((double)s.split("\t").length/2.0); index < s.split("\t").length; index++){
					String seq = s.split("\t")[index];
					int windowSize = 10;
					int permutationsMultiple = 10;
					String newSeq = "";
					int winStart = 0;
					for(winStart = 0; winStart <= (seq.length()-10); winStart = winStart+10){
						String prevSubseq = seq.substring(0+winStart,winStart+windowSize);
						
						for(int p = 0; p < windowSize*permutationsMultiple; p++){
							int perm1 = r.nextInt(windowSize);
							int perm2 = r.nextInt(windowSize);
						
							if(perm1 != perm2){
								String newSubSeq = "";
								char perm1C = prevSubseq.charAt(perm1);
								char perm2C = prevSubseq.charAt(perm2);
								//Substring example: smiles".substring(1, 5) returns "mile"
								if(perm1 == 0 ){
									newSubSeq = perm2C+prevSubseq.substring(1,perm2) + perm1C + prevSubseq.substring(perm2+1);
								}
								if(perm2 == 0){
									newSubSeq = perm1C+prevSubseq.substring(1,perm1) + perm2C + prevSubseq.substring(perm1+1);
								}
								if(perm1 != 0 && perm2 != 0){
									if(perm1 < perm2){
										newSubSeq = prevSubseq.substring(0,perm1) + perm2C + prevSubseq.substring(perm1+1,perm2) + perm1C + prevSubseq.substring(perm2+1); 
									}
									else{
										newSubSeq = prevSubseq.substring(0,perm2) + perm1C + prevSubseq.substring(perm2+1,perm1) + perm2C + prevSubseq.substring(perm1+1);
									}
								}
								prevSubseq = newSubSeq;
							}
							
							
							else{
								p--;
							}
						}
						newSeq += prevSubseq;
					}
					
					if(winStart < seq.length()){
						int charsLeft = seq.length()-winStart;
						String prevSubseq = seq.substring(winStart);
						if(charsLeft > 1){
							for(int p = 0; p < charsLeft*permutationsMultiple; p++){
								int perm1 = r.nextInt(charsLeft);
								int perm2 = r.nextInt(charsLeft);
								if(perm1 != perm2){
									String newSubSeq = "";
									char perm1C = prevSubseq.charAt(perm1);
									char perm2C = prevSubseq.charAt(perm2);
									//Substring example: smiles".substring(1, 5) returns "mile"
									if(perm1 == 0 ){
										newSubSeq = perm2C+prevSubseq.substring(1,perm2) + perm1C + prevSubseq.substring(perm2+1);
									}
									if(perm2 == 0){
										newSubSeq = perm1C+prevSubseq.substring(1,perm1) + perm2C + prevSubseq.substring(perm1+1);
									}
									if(perm1 != 0 && perm2 != 0){
										if(perm1 < perm2){
											newSubSeq = prevSubseq.substring(0,perm1) + perm2C + prevSubseq.substring(perm1+1,perm2) + perm1C + prevSubseq.substring(perm2+1); 
										}
										else{
											newSubSeq = prevSubseq.substring(0,perm2) + perm1C + prevSubseq.substring(perm2+1,perm1) + perm2C + prevSubseq.substring(perm1+1);
										}
									}
									prevSubseq = newSubSeq;
								}
								else{
									p--;
								}
							}
						}
						/*else{
							newSeq += seq.charAt(winStart);
						}*/
						
						newSeq += prevSubseq;
						
						
					}
					
					out.write("\t" + newSeq);
					out.flush();
				}
				out.write("\n");
				s = in.readLine();
			}
			out.close();
			in.close();
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		return outputProteinSeqFile;
	}
}
