
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Random;
import java.util.Set;
import org.apache.commons.math.util.MathUtils;

public class ANNETADistDNAMotifsUTR_20July2012_V4GOODVersion_BiasedSampling_Top1Percent_GetSmallerCores{
	private List<Protein> baits;
	double Dist[][];
	double probMatrix[][];
	
	double triangles[][][];
	double doublets[][];
	double YTriangles[][];
	int groupLimit = 300;
	int maxGroupSize = 1500;
	Hashtable<String, Integer> indices = new Hashtable<String, Integer>();
	
	List<Double> mean;
    List<Double> variance;
    List<Double> stats;

    int numProt = 0;
    double largestEntryInMatrix = 0;

	double roundedDist[][];
    //double roundFactor = 1000.0;
	double roundFactor = 1.0;

    double stopProb = 0.0;
    int totalNumberOfProteins = 0;
   
	List<TreeNode> significantGroups = null;
	double lessSignificantpValue = 1.0;
	double significantpValue = 0.00001;
	double significantpValueGood = 0.000001;
	double significantpValueBest = 0.0000001;
	double significantpValueBetter = 0.00000001;
	double significantpValueMuchBetter = 0.000000001;
	double significantpValueVeryMuchBetter = 0.0000000001;
	double significantpValueUltimate = 0.00000000001;
	double significantpValueUltimate1 = 0.000000000001;
	double significantpValueUltimate2 = 0.0000000000001;
	double significantpValueUltimate3 = 0.00000000000001;
	double significantpValueUltimate4 = 0.000000000000001;
	double significantpValueUltimate5 = 0.0000000000000001;
	double significantpValueUltimate6 = 0.00000000000000001;
	double significantpValueUltimate7 = 0.000000000000000001;
	double significantpValueUltimate8 = 0.0000000000000000001;
	//double significantpValue = 1.0;
	List<List<Double>> dMaxsDistributionForAllSizes;
	double discretizationForKS;
   	double MAX = 0.0;
   
   	public static final String dataset= "hupi";
   	
   	//Changed on 11/21/2014
   	//public static final String Path= "data_nohub/";
   	public static int mLength;
   	public static String firstGeneOnLastLine;
   	public static String DistMatrixFileName;
   	
   	private String TPDDistribution6;
   	private String TPDDistribution5;
   	private String MergedTPDDistribution;
   	private String TPDSimNormalDistribution6;
   	private String TPDSimNormalDistribution5;
   	private String MergedTPDSimNormalDistribution;
   	private String MotifResultFile;
   	private String MotifCoreResultFile;
   	
   	//BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_Connected_noHub.txt BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_DistanceMatrix_Connected_noHub.txt true 8 5 2 100 false false
   	
   	//Changed on 11/21/2014
   	//public void findGroup(String[] args) throws Exception {
   	public Pair<String,String> findGroup(String interactionConnectedFile, String distanceMatrixConnectedFile, boolean doSimulations, int _MotifSize, int _UTRType, int startOfClusterSizeQUESTIONMARK, int endOfClusterSizeQUESTIONMARK, String _samplingBiasFile, String _MotifAnnotationFile, boolean _randomized, boolean _completelyRand, String folder) throws Exception {
   	
		//Changed on 11/21/2014
   		/*
   		String relationFileName = Path + args[0];
		DistMatrixFileName = Path + args[1];
   		boolean DoSimulation = Boolean.parseBoolean(args[2]);
   		int MotifSize = Integer.parseInt(args[3]);
   		int UTRType = Integer.parseInt(args[4]);
   		int start = Integer.parseInt(args[5]);
   		int end = Integer.parseInt(args[6]);
   		boolean randomized = Boolean.parseBoolean(args[7]);
   		boolean completelyRand = Boolean.parseBoolean(args[8]);
   		//String firstLetter = args[9];
   		 */
   		
   		String relationFileName = interactionConnectedFile;
		DistMatrixFileName = distanceMatrixConnectedFile;
   		boolean DoSimulation = doSimulations;
   		int MotifSize = _MotifSize;
   		int UTRType = _UTRType;
   		int start = startOfClusterSizeQUESTIONMARK;
   		int end = endOfClusterSizeQUESTIONMARK;
   		String samplingBiasFile = _samplingBiasFile;
   		String MotifAnnotationFile = _MotifAnnotationFile;
   		boolean randomized = _randomized;
   		boolean completelyRand = _completelyRand;
   		//String firstLetter = args[9];

   		
   		
   		mLength=MotifSize;
   		
   		InputStreamReader input = new InputStreamReader(System.in);
//	    BufferedReader reader = new BufferedReader(input);
        File relationsFile = null;
//        System.out.println("The file is running new2");
//        System.out.println("Want to use HuPi or Krogan or Silico or Collins set?");
//        String s = reader.readLine();
        String s = dataset;
        String DataSet = s;
        int simMatrixChoice = -1;
    	stopProb = 0.15;
    	Hashtable<String,String> prots = null;
        
    	
    	if (s.equals("hupi")){
        	//Jeronimo DataSet
        	//relationsFile = new File("HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridConnectedMay1st.txt");
    		//relationsFile = new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormat.txt");
    		
    		relationsFile = new File(relationFileName);
        	
    		//XAB1 Paper DataSet
        	//relationsFile = new File("src/go/XAB1PaperRelsRatio2.txt");
        	//HPRD Database
        	//relationsFile = new File("src/go/HPRDRelations.txt");
        	simMatrixChoice = 0;
        }
        else if(s.equals("krogan")){
        	relationsFile = new File("src/go/KroganTable7SubsetProteinList.txt");
        	simMatrixChoice = 1;
        	try{
    			File MFile = new File("src/go/KroganTable7SubsetDistanceMatrix.txt");
    			FileReader fRM = new FileReader(MFile);
    			BufferedReader MReader = new BufferedReader(fRM);
    			String MLine = MReader.readLine();
    			numProt = MLine.split("t").length;
    			MReader.close();
    		}catch (Exception e) {
    			e.printStackTrace();
    		}
        }
        else if(s.equalsIgnoreCase("Collins")){
        	relationsFile = new File("src/go/CollinsConnectedHighConfDataSet.txt");
        	simMatrixChoice = 2;
        }
    	
        else{
        	System.out.println("Wrong choice of file");
        	return null;
        }
        
	    FileReader fRRelation = new FileReader(relationsFile);
		BufferedReader relationsReader = new BufferedReader(fRRelation);
		//Output file for the GOCloseGroup were found
		
		List<Pair<Protein,List<Protein>>> proteinList = null;
		if (s.equalsIgnoreCase("Collins")){
			//Read relation file
			List<Relation> relations = createRelationListCollins(relationsReader);
			//Check for baits in relations
			baits = createBaitList(relations);
			//Create data structures for relations
			proteinList = createAdjacencyList(relations,baits);
		}
		else if (s.equals("hupi")){
			//Read relation file
			List<Relation> relations = createRelationList(relationsReader);
			//Check for baits in relations
			baits = createBaitList(relations);
			//Create data structures for relations
			proteinList = createAdjacencyList(relations,baits);
		}
		else{
			proteinList = readAdjacencyList(relationsReader);
		}
		
		/*System.out.println("Do you want to associate UNIPROT accession numbers with proteins (y/n)");
		String answerAcc = reader.readLine();
		if(answerAcc.equals("y")){
			BufferedReader inDB = new BufferedReader(new FileReader(new File("uniprot_sprot_human.dat")));
			Hashtable<String,String> protsSprot = readSeqs(inDB);
			inDB.close();
	
			inDB = new BufferedReader(new FileReader(new File("uniprot_trembl_human.dat")));
			prots = readTremblSeqs(inDB);
			inDB.close();
			
			
			prots.putAll(protsSprot);
			
			
		}*/
		
		
		for(int i = 0; i < proteinList.size(); i++){
			indices.put(proteinList.get(i).getf().getName(),i);
		}
		
		//Read the distance matrix from the file.
		if (!DataSet.equals("krogan")){
			getMatrix(proteinList,simMatrixChoice);
		}
		else{
			getKroganMatrix(proteinList);
		}
		System.out.println("Distance matrix read.");
        System.out.println(Dist.length + " proteins ");
        System.out.println("Largest distance in Matrix = " + largestEntryInMatrix);
        int numberOfProteins = Dist.length;
        totalNumberOfProteins = numberOfProteins;
        if (!DataSet.equals("krogan")){
        	stats = getStats(proteinList);
		}
		else{
			stats = getKroganStats(proteinList);
		}
		int listSize = proteinList.size(); 



/*		System.out.println("Do you want to estimate the pValue witht the triangle method(y/n) ?");
		s = reader.readLine();
		//s = "n";
		if(s.equals("y")){
		   	System.out.println("enumarating all triangles probability");
		   	enumerateAllTrianglesProb(); 
//		  	System.out.println("Do you want to round the mean for the triangle matrix(y/n) ?");
		   	newComputeTriangleBasedEstimatorProbs(listSize,stats,true,false);
//		   	s = reader.readLine();
//		   	if(s.equals("y")){
		   		//newComputeTriangleBasedEstimatorProbs(listSize,stats,true,false,largestPath,DataSet);
		   		//computeTriangleBasedEstimatorProbs(listSize,stats,true,false);
				//computeTriangleBasedEstimatorProbsAllIndependant(listSize,stats,true,false);
//		   	}
//		   	else{
//		   		System.out.println("Weighted sum(y/n)?");
//		   		s = reader.readLine();
//		   		if (s.equals("y")){
		   			//newComputeTriangleBasedEstimatorProbs(listSize,stats,false,true,largestPath,DataSet);;
//		   		}
//		   		else{
		   			//newComputeTriangleBasedEstimatorProbs(listSize,stats,false,false,largestPath,DataSet);
//		   		}
//		   	}
		 }
		

		 System.out.println("Do you want to compute a new upper bound matrix probabilities\nbased on a normal distribution(y/n) ?");
		 s = reader.readLine();
		 //s = "n";
		        
		 boolean compNormalProbOnTheFly = false;
		       
		 mean = null;
		 variance = null;
		        
		 if (s.equals("y")){
			 System.out.println("Computing Means.");
		     mean = computeMean(listSize);
		     System.out.println("Computing Variances.");
		     variance = computeVariance(listSize,mean);
		     computeProbMatrix(listSize,mean,variance,stats,DataSet);
		 }
		        
        System.out.println("Do you want to compute a new lower bound matrix probabilities\nbased on the row method(y/n) ?");
        s = reader.readLine();
        //s = "n";
        if (s.equals("y")){
    	    System.out.println("Computing Individual Matrix...");
        	computeProbMatrices(listSize,stats,DataSet);
        	System.out.println("Computing Final Probability Matrix...");
    	    computeFinalRowProbMatrix(listSize,stats,DataSet);
        }
*/
/*        System.out.println("Do you want to compute a new simulation for the data set(y/n) ?");
        s = reader.readLine();
        //s = "n";
        if(s.equals("y")){*/
        if(DoSimulation){	
        	BufferedReader inP = null;
        	//if(randomized == true){
        	//	inP = new BufferedReader(new FileReader(new File(Path+"SamplingBiasForMotifSize"+MotifSize+"Biogrid_UTR"+UTRType+"_GenomeBrowser_RefSeq_MaxLength500_20Mar13_Randomized.txt")));
        	//}
        	//else{
        		
        		//Changed 11/21/2014
        		//inP = new BufferedReader(new FileReader(new File(Path+"SamplingBiasForMotifSize"+MotifSize+"Biogrid_UTR"+UTRType+"_GenomeBrowser_RefSeq_MaxLength500_nohub_20Mar13.txt")));
        		inP = new BufferedReader(new FileReader(new File(samplingBiasFile)));
        	//}
        	List<Integer> tokensForSampling = getProteinSamplingBias(inP, proteinList);
        	System.out.println("How many repetitions do you want to do:");
        	//int rep = 10000000;
        	//int rep = 1000000;
        	int rep = 1000000;
        	if(start > 300){
        		rep = 100000;
        	}
        	System.out.println("Simulating probabilities...");
        	//Changed 11/21/2014
        	if(numberOfProteins-1 <= 300){
        		simulateRealLife(listSize,stats,rep,DataSet,tokensForSampling,proteinList,start,numberOfProteins-1,MotifSize,UTRType,randomized);

        		//Changed on 11/21/2014
        		MergedTPDDistribution = TPDDistribution6;
        		
        		

        	}
        	else{
        		simulateRealLife(listSize,stats,rep,DataSet,tokensForSampling,proteinList,start,300,MotifSize,UTRType,randomized);
        		
        		
        		//Changed 11/21/2014
        		if(numberOfProteins-1< 1500){
            		simulateRealLife(listSize,stats,100000,DataSet,tokensForSampling,proteinList,301,numberOfProteins-1,MotifSize,UTRType,randomized);
            	}
            	else{
            		simulateRealLife(listSize,stats,100000,DataSet,tokensForSampling,proteinList,301,1500,MotifSize,UTRType,randomized);
            	}
        		
        		//Changed on 11/21/2014
        		MergedTPDDistribution = TPDDistribution5+"and10Power6.txt";
        		BufferedWriter outMerged = new BufferedWriter(new FileWriter(new File(MergedTPDDistribution)));
        		BufferedReader inForMerged = new BufferedReader(new FileReader(new File(TPDDistribution6)));
        		//Changed on 11/21/2014
        		String lineForMerged = inForMerged.readLine();
        		while(lineForMerged != null){
        			outMerged.write(lineForMerged + "\n");
        			outMerged.flush();
        			lineForMerged = inForMerged.readLine();
        		}
        		//Changed on 11/21/2014
        		inForMerged = new BufferedReader(new FileReader(new File(TPDDistribution5)));
        		lineForMerged = inForMerged.readLine();
        		while(lineForMerged != null){
        			outMerged.write(lineForMerged + "\n");
        			outMerged.flush();
        			lineForMerged = inForMerged.readLine();
        		}
        		outMerged.close();
        		
        		
        		
        	}
        	//simulateRealLife(listSize,stats,rep,DataSet,tokensForSampling,proteinList,start,end,MotifSize,UTRType,randomized);
        	
        	
        	//Changed 11/21/2014
        	if(numberOfProteins-1 < 300){
        		simulateMeanVar(listSize,stats,rep,DataSet,tokensForSampling,proteinList,start,numberOfProteins-1,MotifSize,UTRType,randomized);
        		//Changed on 11/21/2014
        		MergedTPDSimNormalDistribution = TPDSimNormalDistribution6;
        	}
        	else{
        		simulateMeanVar(listSize,stats,rep,DataSet,tokensForSampling,proteinList,start,300,MotifSize,UTRType,randomized);
        		
        		if(numberOfProteins-1 < 1500){
        			simulateMeanVar(listSize,stats,100000,DataSet,tokensForSampling,proteinList,301,numberOfProteins-1,MotifSize,UTRType,randomized);
        		}
        		else{
        			simulateMeanVar(listSize,stats,100000,DataSet,tokensForSampling,proteinList,301,1500,MotifSize,UTRType,randomized);
        		}
        		
        		//Changed on 11/21/2014
        		MergedTPDSimNormalDistribution = TPDSimNormalDistribution5+"and10Power6.txt";
        		BufferedWriter outMerged = new BufferedWriter(new FileWriter(new File(MergedTPDSimNormalDistribution)));
        		BufferedReader inForMerged = new BufferedReader(new FileReader(new File(TPDSimNormalDistribution6)));
        		//Changed on 11/21/2014
        		String lineForMerged = inForMerged.readLine();
        		while(lineForMerged != null){
        			outMerged.write(lineForMerged + "\n");
        			outMerged.flush();
        			lineForMerged = inForMerged.readLine();
        		}
        		//Changed on 11/21/2014
        		inForMerged = new BufferedReader(new FileReader(new File(TPDSimNormalDistribution5)));
        		lineForMerged = inForMerged.readLine();
        		while(lineForMerged != null){
        			outMerged.write(lineForMerged + "\n");
        			outMerged.flush();
        			lineForMerged = inForMerged.readLine();
        		}
        		outMerged.close();
        		
        	}
        }	
        	
/*        }*/
	    
        //BufferedReader inGeneSets = new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size8_20July2012_GoodFormat_V2.txt")));
        //BufferedReader inGeneSets = new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size6_Randomized_20July2012_GoodFormat_V3.txt")));
        //BufferedReader inGeneSets = new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid5\'UTRFrom5\'RACE_WithPosDist_Size8_Randomized_17Sept2012_GoodFormat.txt")));
        BufferedReader inGeneSets = null; 
        if(randomized){
        	if(completelyRand){
        		
        		//Changed 11/21/2014
        		//inGeneSets = new BufferedReader(new FileReader(new File("../CreateUTRMotifAnnotation/data_noHub/AllMotifSize"+MotifSize+"_UTR"+UTRType+"_GenomeBrowser_RefSeq_MaxLength500_MotifWith1500GenesOrLessInBothSet_nohub_20Mar13_CompletelyRandomized_Randomized.txt")));
        		inGeneSets = new BufferedReader(new FileReader(new File(MotifAnnotationFile)));
        		
        	}
        	else{
        		//Changed 11/21/2014
        		//inGeneSets = new BufferedReader(new FileReader(new File("../CreateUTRMotifAnnotation/data_noHub/AllMotifSize"+MotifSize+"_UTR"+UTRType+"_GenomeBrowser_RefSeq_MaxLength500_MotifWith1500GenesOrLessInBothSet_nohub_20Mar13_Randomized.txt")));
        		inGeneSets = new BufferedReader(new FileReader(new File(MotifAnnotationFile)));
        	}
        }
        else{
        	//Changed 11/21/2014
        	//inGeneSets = new BufferedReader(new FileReader(new File("../CreateUTRMotifAnnotation/data_noHub/AllMotifSize"+MotifSize+"_UTR"+UTRType+"_GenomeBrowser_RefSeq_MaxLength500_MotifWith1500GenesOrLessInBothSet_nohub_20Mar13.txt")));
        	inGeneSets = new BufferedReader(new FileReader(new File(MotifAnnotationFile)));
        }
        
        System.out.println("Computing K-S statistic null distribution");
        //TO Uncomment FOR KS
        //KSdNullDistribution();
        
        
        
        //System.out.println("Computing K-S Dmax for all motifs");
        //Hashtable<String,Double> motifsDmaxs = getDmaxForAllMotifs(new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsAllSameSpecialCharYeastBiogrid1000Upstream20Sept2011WithPositionDistribution.txt"))));
        
        //Hashtable<String,Double> motifsDmaxs = getDmaxForAllMotifs(new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size6_20July2012_GoodFormat.txt"))));
        //Hashtable<String,Double> motifsDmaxs = getDmaxForAllMotifs(new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size7_20July2012_GoodFormat.txt"))));
        
        //Hashtable<String,Double> motifsDmaxs = getDmaxForAllMotifs(new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size6_Randomized_20July2012_GoodFormat.txt"))));
        //Hashtable<String,Double> motifsDmaxs = getDmaxForAllMotifs(new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size7_Randomized_20July2012_GoodFormat.txt"))));
        //Hashtable<String,Double> motifsDmaxs = getDmaxForAllMotifs(new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size8_20July2012_GoodFormat.txt"))));
        //Hashtable<String,Double> motifsDmaxs = getDmaxForAllMotifs(new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size8_Randomized_20July2012_GoodFormat.txt"))));
        
        
        
        System.out.println("Loading Gene Sets...");
        
        //BufferedReader inGeneSets = new BufferedReader(new FileReader(new File("ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size7_20July2012_GoodFormat.txt")));

        //BufferedReader inGeneSets = new BufferedReader(new FileReader(new File(ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size6_Randomized_20July2012_GoodFormat.txt)));
        //BufferedReader inGeneSets = new BufferedReader(new FileReader(new File(ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size7_Randomized_20July2012_GoodFormat.txt)));
        //BufferedReader inGeneSets = new BufferedReader(new FileReader(new File(ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size8_20July2012_GoodFormat.txt)));
        //BufferedReader inGeneSets = new BufferedReader(new FileReader(new File(ComplexeMotifsAssociationsDiffSpecialChar_YeastBiogrid1000UpstreamWithPosDist_Size8_Randomized_20July2012_GoodFormat.txt)));
        
        
        
      //Set<ANGeneSet> ANGeneSets = loadGeneSets(proteinList,inGeneSets);
        //System.out.println("Gene Sets loaded");
        //System.out.println("Number of Gene sets " + ANGeneSets.size());
        
    	significantGroups = new ArrayList<TreeNode>();
    	
    	BufferedWriter out = null;
    	if(randomized){
    		if(completelyRand){
    			//out = new BufferedWriter(new FileWriter(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500__GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "_CompletelyRandomized_FirstLetter"+firstLetter+".txt"));
    			
    			//Changed 11/21/2014
    			//out = new BufferedWriter(new FileWriter(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500__GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "_CompletelyRandomized.txt"));
    			MotifResultFile = folder+"/"+"ComplexeMotifs_MotifSize"+MotifSize+"_"+UTRType+"'UTR_MaxLength500_GenomeBrowser_nohub_top1Percent_BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "_CompletelyRandomized.txt";
    			out = new BufferedWriter(new FileWriter(MotifResultFile));
    		}
    		else{
    			//out = new BufferedWriter(new FileWriter(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500__GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "_Randomized_FirstLetter"+firstLetter+".txt"));
    			
    			//Changed 11/21/2014
    			//out = new BufferedWriter(new FileWriter(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500__GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "_Randomized.txt"));
    			//MotifResultFile = folder+"/"+"OUTPUT_ComplexeMotifs_MotifSize"+MotifSize+"_"+UTRType+"'UTR_MaxLength500_GenomeBrowser_nohub_top1Percent_BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "_Randomized.txt";
    			MotifResultFile = folder+"/"+"Output_Randomized_Sequences.txt";
    			out = new BufferedWriter(new FileWriter(MotifResultFile));
    		}
    	}
    	else{
    		//out = new BufferedWriter(new FileWriter(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500__GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "_FirstLetter"+firstLetter+".txt"));
    		
    		//Changed 11/21/2014
    		//out = new BufferedWriter(new FileWriter(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500__GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "SmallCores_OBSOLETE.txt"));
    		MotifResultFile = folder+"/"+"ComplexeMotifs_MotifSize"+MotifSize+"_"+UTRType+"'UTR_MaxLength500_GenomeBrowser_nohub_top1Percent_BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue +".txt";
    		out = new BufferedWriter(new FileWriter(MotifResultFile));
    	}

    	
    	//Changed 11/21/2014
    	/*
    	 * This part of the code is used to generate the labels for the hierarchical clustering tree in the figure of the paper
    	 
    	BufferedReader in = new BufferedReader(new FileReader(new File(Path + "TreeOrderLabel_NoHub_top1percent.txt")));
    	List<String> motifsToGetCore = new ArrayList<String>();
    	s = in.readLine();
    	while(s != null){
    		String[] split = s.split("\t");
    		motifsToGetCore.add(split[1]);
    		s = in.readLine();
    	}
    	*/
    	
    	
    	
    	
    	//BufferedWriter out = new BufferedWriter(new FileWriter("BIOGRID_Yeast_Size8_BiasedSampling_Randomized_17Sept2012_5\'UTRFrom5\'RACE_UpToGroupSize_Sims10^7To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +significantpValue + "WithKSTest.txt"));
    	
    	//BufferedWriter out = new BufferedWriter(new FileWriter("BIOGRID_Yeast_Size8_20July2012_1000Upstream_UpToGroupSize_Sims10^7To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +significantpValue + "WithKSTest_V2_attempt2_LowerT.txt"));
        //Set<List<ANGeneSet>> goodGeneSets = findSignificantGeneSets(proteinList,DataSet, inGeneSets,out,false,MotifSize,UTRType,randomized,completelyRand,firstLetter);
    	
    	//Changed 11/21/2014
    	//Set<List<ANGeneSet>> goodGeneSets = findSignificantGeneSets(proteinList,DataSet, inGeneSets,out,false,MotifSize,UTRType,randomized,completelyRand,motifsToGetCore);
    	maxGroupSize = numberOfProteins-1;
    	Set<List<ANGeneSet>> goodGeneSets = findSignificantGeneSets(proteinList,DataSet, inGeneSets,out,false,MotifSize,UTRType,randomized,completelyRand,folder);
       
    	Pair<String,String> outputFileAndCoreFile = new Pair<String,String>(MotifResultFile,MotifCoreResultFile);
    	return outputFileAndCoreFile;
        
	}
   	
   	private List<Integer> getProteinSamplingBias(BufferedReader in, List<Pair<Protein,List<Protein>>> ProteinList){
   		//ProteinsInNetWorkWithSeqsYeastBiogrid5\'UTRFrom5\'RACE_17Sept2012.txt
	   	Hashtable<String,Integer> ProteinBiases = new Hashtable<String,Integer>();
	    List<Integer> lengths = new ArrayList<Integer>();
	   	try{
	   		String s = in.readLine();
	   		while(s != null){
	   			String[] split = s.split("\t");
	   			String proteinName = split[0];
	   			Double length = Double.parseDouble(split[1]);
	   			
	   			lengths.add((int)Math.round(length));
	   			ProteinBiases.put(proteinName, (int)Math.round(length));
	   			s = in.readLine();
	   		}
   		}catch (Exception e) {
			e.printStackTrace();
		}
	   	
	   	Collections.sort(lengths);
	   	//double ThirdMinOccurences = lengths.get(9); // more like 10th min occurence
	   	double ThirdMinOccurences = 1.0; // more like 10th min occurence
	   	System.out.println("DivisionFactor = " + ThirdMinOccurences);
	   	
	   	
	   	List<Integer> tokensForSampling = new ArrayList<Integer>();
	   	for(int i = 0; i < ProteinList.size(); i++){
			if(ProteinBiases.containsKey(ProteinList.get(i).first.getName())){
				int numberOfTokens = 0;
				if(ProteinBiases.get(ProteinList.get(i).first.getName()) < (mLength+1) ){
					numberOfTokens = 1;
				}
				else{
					numberOfTokens = (int)Math.round((double)(ProteinBiases.get(ProteinList.get(i).first.getName())-7) / ThirdMinOccurences);
				}
				if(numberOfTokens < 1){
					numberOfTokens = 1;
				}
				System.out.println("NumberOfTokens " + numberOfTokens);
				for(int j = 0; j < numberOfTokens; j++){
					tokensForSampling.add(i);
					
				}
			}
			
		}
	   	
   		return tokensForSampling;
   	}
   	
   	private double cumulValueUniform1to1000(double index){
   		double a = 1.0;
   		double b = 1000.0;
   		return ((index-a)/(b-a));
   	}
   	
   	private Hashtable<String,Double> getDmaxForAllMotifs(BufferedReader in){
   		Hashtable<String,Double> MotifsDmaxs = new Hashtable<String,Double>();
   		try{
   			String s = in.readLine();
   			while(s!=null){
	   			
	   			String[] split = s.split("\t");
	   			String motif = split[0];
	   			int numberOfItems = split.length-1;
	   			s = in.readLine();
	   			split = s.split("\t");
	   			List<Integer> positions = new ArrayList<Integer>();
	   			for(int i = 1; i < split.length; i++){
	   				if(!split[i].equals("0.0")){
	   					for(int j = 0; j < (int)Math.round(Double.parseDouble(split[i]) * numberOfItems); j++){
	   						positions.add(i);
	   					}
	   				}
	   			}
	   			
	   			Collections.sort(positions);
	   			
	   			double fraction = 1.0/(double)numberOfItems;
   				double dMax = 0.0;
   				double uniformValue = 0.0;
   				for(int j = 0; j < positions.size(); j++){
   					//Problem here
   					uniformValue = cumulValueUniform1to1000(positions.get(j));
   					double d = Math.abs(j*fraction - uniformValue);
   					if(d > dMax){
   						dMax = d; 
   					}
   					
   					d = Math.abs(((j+1)*fraction) - uniformValue);
   					if(d > dMax){
   						dMax = d; 
   					}
   				}
   				MotifsDmaxs.put(motif, dMax);
	
	   			s = in.readLine();
   			}
   		
   		}catch (Exception e) {
			e.printStackTrace();
		}
   		return MotifsDmaxs;
   		
   	}
   	
   	
   	private double getPvalueFromDvalue(int n, double Dvalue){
   		List<Double> dist = dMaxsDistributionForAllSizes.get(n);
   		double pValue = 0.0;
   		for(int i = (int)(Dvalue*discretizationForKS); i < dist.size(); i++){
   			pValue += dist.get(i);
   		}
   		return pValue;
   	}
   	
   	private void KSdNullDistribution(){
   		Random r = new Random();
   		dMaxsDistributionForAllSizes = new ArrayList<List<Double>>();
   		dMaxsDistributionForAllSizes.add(new ArrayList<Double>());
   		dMaxsDistributionForAllSizes.add(new ArrayList<Double>());
   		dMaxsDistributionForAllSizes.add(new ArrayList<Double>());
   		for(int i = 3; i < (maxGroupSize+1); i++){
   			System.out.println(i);
   			List<Double> dMaxs = new ArrayList<Double>();
   			for(int rep = 0; rep < 10000; rep++){
   				List<Double> ds = new ArrayList<Double>();
   				for(int j = 0; j < i; j++){
   					ds.add(r.nextDouble());
   				}
   				Collections.sort(ds);
   				double fraction = 1.0/(double)ds.size();
   				double dMax = 0.0;
   				double uniformValue = 0.0;
   				for(int j = 0; j < ds.size(); j++){
   					double d = Math.abs(ds.get(j) - uniformValue);
   					if(d > dMax){
   						dMax = d; 
   					}
   					uniformValue += fraction;
   					d = Math.abs(ds.get(j) - uniformValue);
   					if(d > dMax){
   						dMax = d; 
   					}
   				}
   				dMaxs.add(dMax);
   			}
   			Collections.sort(dMaxs);
   			List<Double> distribution = new ArrayList<Double>();
   			Double densityOfAnElement = 1.0/(double)dMaxs.size();
   			discretizationForKS = 1000.0;
   			// D values are discritized to the resolution of 1000. So if d value is 0.001 its density will be a index 1
   			//if it is 2.0456 it will be at index 2045.
   			//0.0001	0.001	0.002	0.1043
   			//0			1		2		104
   			
   			
   			//example:
/*   			k = 0
   			k + 1 = 1
   			j = 0
   			dMaxs(j) = 0.0001
   			dMaxs(j)*1000 = 0.1;
   			
   			j = 1
   			dMaxs(j) = 0.0002
   			dMaxs(j)*1000 = 0.2;
   			
   			j = 2 
   			dMaxs(j) = 0.0025
   			dMaxs(j)*1000 = 2.5;
   			
   			k = 1
   			
   			wanted: 
   			0
   			density added*/
   			
   			for(int j = 0; j <= discretizationForKS; j++){
   				distribution.add(0.0);
   			}
   			double sum1 = 0.0; 
   			for(int j = 0; j < dMaxs.size(); j++){
   				int index = (int)Math.floor(dMaxs.get(j)*discretizationForKS);
   				distribution.set(index, distribution.get(index) + densityOfAnElement);
   				sum1 += densityOfAnElement;
   			}
   			
   			
   			
/*   			int k = 0;
   			for(int j = 0; j < dMaxs.size(); j=j){
   				while(k+1 <= dMaxs.get(j)*discretizationForKS){
   					distribution.add(0.0);
   					k++;
   				}
   				distribution.add(densityOfAnElement);
   				j++;
   				if(j < dMaxs.size()){
   	   				while(dMaxs.get(j)*discretizationForKS < k+1){
   	   					distribution.set(k,distribution.get(k)+densityOfAnElement);
   	   					j++;
   	   					if(j >= dMaxs.size()){
   	   						break;
   	   					}
   	   				}
   				}
   				k++;
   			}*/
   		
   			
   			dMaxsDistributionForAllSizes.add(distribution);
   		}
   		try{
	   		BufferedWriter out = new BufferedWriter(new FileWriter(new File("KS_D_NullDistribution.txt")));
	   		for(List<Double> distribution: dMaxsDistributionForAllSizes){
	   			double sum = 0.0;
	   			for(int i = 0; i < distribution.size(); i++){
	   				sum+=distribution.get(i);
	   				out.write(distribution.get(i)+"\t");
	   				out.flush();
	   			}
	   			out.write("\n");
	   			
	   		}
	   		out.close();
   		}catch (Exception e) {
			e.printStackTrace();
		}
   	}
   	
	
	private double probabilityApproximation(double djk, double dik, int betaMinusa, int n){
		double prob = 0.0;
		try{
			// djk = X
			// dik = Y
			if (djk > 19 || dik >  19 || betaMinusa >= 20){
				return 0.0;
			}
			int fdjk = (int)Math.floor(djk);
			int cdjk = (int)Math.ceil(djk);
			int fdik = (int)Math.floor(dik);
			int cdik = (int)Math.ceil(dik);
			
			int comb = (int)MathUtils.binomialCoefficientDouble(n-1,2);
			double fdjkfdikProb = triangles[fdjk][fdik][betaMinusa];
			double fdjkcdikProb = triangles[fdjk][cdik][betaMinusa];
			double cdjkfdikProb = triangles[cdjk][fdik][betaMinusa];
			double cdjkcdikProb = triangles[cdjk][cdik][betaMinusa];
			
			double expfdjkfdikProb = ((1 - (djk - fdjk))) * (1 - (dik - fdik))*(n-2); 
			double expfdjkcdikProb = ((1 - (djk - fdjk))) * (dik - fdik)*(n-2);
			double expcdjkfdikProb = ((djk - fdjk)) * (1-(dik - fdik))*(n-2);
			double expcdjkcdikProb = ((djk - fdjk)) * (dik - fdik)*(n-2);
			
			double probff = 0.0;
			double probfc = 0.0;
			double probcf = 0.0;
			double probcc = 0.0;
			if (fdjkfdikProb == 0 && expfdjkfdikProb == 0){
				probff = 0.0;
			}
			else{
				probff = Math.pow(fdjkfdikProb,expfdjkfdikProb);
			}
			if (fdjkcdikProb == 0 && expfdjkcdikProb == 0){
				probfc = 0.0;
			}
			else{
				probfc = Math.pow(fdjkcdikProb,expfdjkcdikProb);
			}
			if (cdjkfdikProb == 0 && expcdjkfdikProb == 0){
				probcf = 0.0;
			}
			else{
				probcf = Math.pow(cdjkfdikProb,expcdjkfdikProb);
			}
			if (cdjkcdikProb == 0 && expcdjkcdikProb == 0){
				probcc = 0.0;
			}
			else{
				probcc = Math.pow(cdjkcdikProb,expcdjkcdikProb);
			}
			prob = probff * probfc * probcf * probcc;
			
			if(Math.pow(stats.get(betaMinusa),(n-2)-1) == 0.0){
				prob = 0.0;
			}
			else{
				prob = prob/Math.pow(stats.get(betaMinusa),(n-2)-1);
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return prob;	



	}
	
	private void newComputeTriangleBasedEstimatorProbs(int listSize, List<Double> pathStats, boolean round, boolean weightedSum){
		try{
				
			BufferedWriter out = new BufferedWriter(new FileWriter(new File("src/go/HuPIOriginalTri2to50protsWeightedSimRoundp0.15RF1000.0WMax500.txt")));
			//BufferedWriter out = new BufferedWriter(new FileWriter(new File("src/go/mlaval/Data/HuPIOriginal/.txt")));
			int numberOfProtsInSubset = 50;
			int maxComb = (int)MathUtils.binomialCoefficientDouble(numberOfProtsInSubset,2);
			double backUpX[] = new double[(int)(maxComb*MAX)+1];
			for(int i = 3; i <= numberOfProtsInSubset; i++){
				System.out.println("i" + i);
				int comb = (int)MathUtils.binomialCoefficientDouble(i,2);
				double combNMinus1 = (double)MathUtils.binomialCoefficientDouble(i-1,2);
				double YnM1[][] = new double[(int)(comb*MAX)+1][(int)(i*MAX)+2];
				double nextY[][] = new double[(int)(comb*MAX)+1][(int)(i*MAX)+2];
				double lowerY[][] = new double[(int)(comb*MAX)+1][(int)(i*MAX)+2];
			//	List<Pair<Pair<Double,Double>,List<Pair<Integer,Double>>>> Zs = new ArrayList<Pair<Pair<Double,Double>,List<Pair<Integer,Double>>>>();
			//	HashMap<NormPair, List<Double>> norms = new HashMap<NormPair, List<Double>>();
			//	HashMap<NormPair, List<Double>> newNorms = new HashMap<NormPair, List<Double>>();
				HashMap<String, List<Double>> norms = new HashMap<String, List<Double>>();
				HashMap<String, List<Double>> newNorms = new HashMap<String, List<Double>>();
				
				if (i != 3){
					for (int alphaMbeta = 0; alphaMbeta < (((comb*MAX)+1)-(i*MAX)); alphaMbeta++){
						double djkR = Math.round((double)(alphaMbeta)/(double)combNMinus1);
						if(djkR >= doublets.length || djkR >= triangles.length){
							continue;
						}
						for ( int beta = 0; beta < (i*MAX+1); beta++){
							double Y = 0;
							int startA=0;
							if (beta - MAX <= 0){
								startA = 0;
							}
							else{
								startA = beta-(int)MAX;
							}
							
							for (int a = startA; a <= beta; a++){
								double dikR = Math.round((double)a/(double)(3-2));
								if (a >= doublets.length || (dikR>=triangles.length)){
									break;
								}
								if ((beta-a)<triangles.length && ((beta-a)>0)){
									double triApprox = 0.0;
									triApprox = triangles[(int)djkR][(int)dikR][beta-a];
									Y = Y + doublets[(int)djkR][a] * triApprox;
								}
							}
							lowerY[alphaMbeta][beta] = Y;
							nextY[alphaMbeta][beta] = Y;
						}
					}
					for (int index1 = 0; index1 < ((comb*MAX)+1); index1++){
						double sum = 0;
						for(int index2 = 0; index2 < ((i*MAX)+2); index2++){
							sum += lowerY[index1][index2];
						}
						for (int index2 = 0; index2 < ((i*MAX)+2); index2++){
							if (sum == 0.0){
								lowerY[index1][index2] = 0.0;
							}
							else{
								lowerY[index1][index2] = lowerY[index1][index2]/sum;
							}
						}
						
					}
					int counter = 4;
					for(int j = i; j > 4; j--){
						for (int alphaMbeta = 0; alphaMbeta < (((comb*MAX)+1)-(i*MAX)); alphaMbeta++){
							double djkR = Math.round((double)(alphaMbeta)/(double)combNMinus1);
							if(djkR >= triangles.length){
								continue;
							}
							for ( int beta = 0; beta < (i*MAX+1); beta++){
								double Y = 0;
								int startA=0;
								if (beta - MAX <= 0){
									startA = 0;
								}
								else{
									startA = beta-(int)MAX;
								}
								for (int a = startA; a <= beta; a++){
									double dikR = Math.round((double)a/(double)(counter-2));
									if ((a >= (i*MAX)+2) || dikR >= triangles.length){
										break;
									}
									if ((beta-a)<triangles.length && (beta-a) > 0){
										double triApprox = 0.0;
										triApprox = triangles[(int)djkR][(int)dikR][beta-a];
										Y = Y + lowerY[alphaMbeta][a] * triApprox;
										
									}
								}
								
								nextY[alphaMbeta][beta] = Y;
							}
						}
						for (int index1 = 0; index1 < ((comb*MAX)+1); index1++){
							double sum = 0.0;
							for(int index2 = 0; index2 < ((i*MAX)+2); index2++){
								sum += nextY[index1][index2];
							}
							for (int index2 = 0; index2 < ((i*MAX)+2); index2++){
								if (sum == 0.0){
									lowerY[index1][index2] = 0.0;
								}
								else{
									lowerY[index1][index2] = nextY[index1][index2]/sum;
								}
							}
						}
						counter++;
					}
				}
				
				for(int alphaMbeta = 0; alphaMbeta < ((comb*MAX)+1); alphaMbeta++){
					double djkR = Math.round((double)(alphaMbeta)/(double)combNMinus1);
					if(djkR >= triangles.length){
						continue;
					}
					if (i == 3){
						if (alphaMbeta >= doublets.length){
							break;
						}
					}
					for(int beta = 0; beta < (i*MAX+1); beta++){
						double Y = 0.0;
						int startA=0;
						if (beta - MAX <= 0){
							startA = 0;
						}
						else{
							startA = beta-(int)MAX;
						}
						for(int a = startA; a <= beta; a++){
							double dikR = Math.round((double)a/(double)(i-2));
							if (dikR >= triangles.length){
								break;
							}
							if (i == 3){
								if (a >= doublets.length){
									break;
								}
								if ((beta-a)<triangles.length && (beta-a) >= 0){
									double triApprox = 0.0;
									triApprox = triangles[(int)djkR][(int)dikR][beta-a];
									Y = Y + doublets[alphaMbeta][a]*triApprox;
								}
							}
							else{
								if (a >= (i*MAX)+2){
									break;
								}
								if ((beta-a)<triangles.length && (beta-a) >= 0){
									double triApprox = 0.0;
									triApprox = triangles[(int)djkR][(int)dikR][beta-a];
									Y = Y + nextY[alphaMbeta][a] * triApprox;
								}
							}
						}
						YnM1[alphaMbeta][beta] = Y;
					}
				}
				
				if(i > 3){
					for(int count = 0; count < ((comb*MAX)+1); count++){
						double sum = 0.0;
						for(int count2 = 0; count2 < ((i*MAX)+2); count2++){
							sum = sum + YnM1[count][count2];
						}
						for(int count2 = 0; count2< ((i*MAX)+2); count2++){
							if(sum == 0.0){
								YnM1[count][count2]=0.0;
							}
							else{
								YnM1[count][count2] = YnM1[count][count2]/sum;
							}
						}
					}
				}
				
				
				double Xn[] = new double[(int)(comb*MAX)+1];
				int zeroCounter = 0;
				boolean seenNonZero = false;
				for(int alpha = 0; alpha <= (int)(comb*MAX); alpha++){
					double X = 0;
					for(int beta = 0; beta <= ((i*MAX)+1); beta++){
						if (beta > alpha){
							break;
						}
						if (i == 3){
							if ( ((alpha-beta)<stats.size()) && ((alpha-beta)<((comb*MAX)+1)) && (beta<((i*MAX)+2))){
								X = X + stats.get(alpha-beta) * YnM1[alpha-beta][beta];
							}
						}
						else{
							if (((alpha-beta)<backUpX.length) && (beta<((comb*MAX)+1)) && ((alpha-beta)<((i*MAX)+2))){
								X = X + backUpX[(alpha-beta)] * YnM1[alpha-beta][beta];
							}
						}
					}
					if (X != 0.0){
						seenNonZero = true;
					}
					if (X == 0.0 && seenNonZero == true){
						zeroCounter++;
					}
					if (zeroCounter >= 100 && seenNonZero == true){
						break;
					}
					Xn[alpha] = X;
				}
				double sumP = 0.0;
				for (int j = 0; j <= (int)(comb*MAX); j++){
					sumP += Xn[j];
					backUpX[j]= Xn[j];
				}
				System.out.println("Sum of prob for"+ i +"proteins = " + sumP);
				for (int j = 0; j <= (int)(comb*MAX); j++){
					out.write(Xn[j]+",");
					out.flush();
				}	
				out.write("\n");
				out.flush();
			}
			out.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
	}


    
	private void enumerateAllTrianglesProb(){
		double matrixDim = MAX+1;
		triangles = new double[(int)matrixDim][(int)matrixDim][(int)matrixDim];
		double numTriangles[][] = new double[(int)matrixDim][(int)matrixDim];
		doublets = new double[(int)matrixDim][(int)matrixDim];
		double numSingles[] = new double[(int)matrixDim];
		for (int i = 0; i < triangles.length; i++){
			numSingles[i]= 0.0;
			for(int j = 0; j < triangles.length; j++){
				numTriangles[i][j] = 0.0;
				doublets[i][j] = 0.0;
				for (int k = 0; k < triangles.length; k++){
					triangles[i][j][k] = 0.0;
				}
			}
		}
		System.out.println("MAX " + MAX);
		for(int j = 0; j < Dist.length; j++){
			System.out.println("row " + j);
			for(int k = 0; k < Dist.length; k++){
				for(int i = 0; i < Dist.length; i++){
					if (i == j || j == k || i == k){
						continue;
					}
					int jk = (int)Math.round(Dist[j][k]*roundFactor);
					int ij = (int)Math.round(Dist[i][j]*roundFactor);
					int ik = (int)Math.round(Dist[i][k]*roundFactor);
					doublets[jk][ij]++;
					numSingles[jk]++;
					triangles[jk][ik][ij]++;
					numTriangles[jk][ik]++;
				}
			}
		}
		
		System.out.println("Computing triangles probabilities");
		for(int i = 0; i < triangles.length; i++){
			for(int j = 0; j < triangles.length; j++){
				if (numSingles[i] == 0.0){
					doublets[i][j] = 0.0;
				}
				else{
					doublets[i][j] = doublets[i][j]/numSingles[i];
				}
				for(int k = 0; k < triangles.length; k++){
					if (numTriangles[i][j] == 0.0){
						triangles[i][j][k] = 0.0;
					}else{
						triangles[i][j][k] = triangles[i][j][k]/numTriangles[i][j];
					}
				}
			}
		}
	}
    
	private void makeColumn(){
		try{
			BufferedReader avgM = new BufferedReader(new FileReader(new File ("src/go/RowRemodelRoundP0.25Prots15Round.txt")));
			String l = avgM.readLine();
			l = avgM.readLine();
			l = avgM.readLine();
			l = avgM.readLine();
			l = avgM.readLine();
			l = avgM.readLine();
			l = avgM.readLine();
			l = avgM.readLine();
			l = avgM.readLine();
			String[] lsplit = l.split(",");
			BufferedWriter out = new BufferedWriter(new FileWriter("src/go/TTTTTTTEEESSSSSSTTTTTTTT.txt"));
			for (int i = 0; i < lsplit.length; i++){
				out.write(Double.parseDouble(lsplit[i])+"\n");
			}
			out.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private boolean alreadyIn(int ind1, List<Integer> l){
		for(Integer i: l){
			if (ind1 == i){
				return true;
			}
		}
		return false;
	}
	
	private void simulateMeanVar(int ps,List<Double> pathStats, int reps, String DataSet,/*Hashtable<String,Integer> proteinBiases,*/List<Integer> tokensForSampling, List<Pair<Protein,List<Protein>>> ProteinList, int pStart, int pEnd, int MotifSize, int UTRType, boolean randomized){
		try{
			
			int start = pStart;
			int end = pEnd;
			//BufferedReader in = new BufferedReader(new FileReader(new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormatDistanceSim300to301_10Power4Proteins.txt")));
			//BufferedReader in = new BufferedReader(new FileReader(new File("BIOGRID_Yeast_3.1.90.tab2_20July2012_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power5Samplings.txt")));
			//BufferedReader in = new BufferedReader(new FileReader(new File("BIOGRID_Yeast_3.1.90.tab2_20July2012_Connected_Distance_Sim2to300_10Power6_BiasedSamplings.txt")));
			
			BufferedReader in = null;
			if(reps == 1000000){
				//if(randomized == true){										
				//	in = new BufferedReader(new FileReader(new File(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power6_12Mar13_Randomized_BiasedSamplings.txt")));
				//}
				//else{
					
					//Changed on 11/21/2014
					//in = new BufferedReader(new FileReader(new File(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power6_nohub_top1percent_20Mar13_BiasedSamplings.txt")));
					in = new BufferedReader(new FileReader(new File(TPDDistribution6)));
				
				//}
			}
			else if(reps == 100000){
				//if(randomized == true){
				//	in = new BufferedReader(new FileReader(new File(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power5_12Mar13_Randomized_BiasedSamplings.txt")));
				//}
				//else{
				
					//Changed on 11/21/2014
					//in = new BufferedReader(new FileReader(new File(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power5_nohub_top1percent_20Mar13_BiasedSamplings.txt")));
					in = new BufferedReader(new FileReader(new File(TPDDistribution5)));
				
				//}
			}
			
			BufferedWriter out = null;
			if(DataSet.equals("hupi")){
				//out = new BufferedWriter(new FileWriter("src/go/HuPINormalProbMatrix3to100prots"+stopProb + "RF" + roundFactor+ "_14Nov2010.txt"));
				//out = new BufferedWriter(new FileWriter("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormatDistanceNormalApprox300to301_10Power4SamplingsProteins.txt"));
				//out = new BufferedWriter(new FileWriter("BIOGRID_Yeast_3.1.90.tab2_20July2012_Connected_Distance_SimNormal"+start+"to"+(end-1)+"_10Power5Samplings.txt"));
				//out = new BufferedWriter(new FileWriter("BIOGRID_Yeast_3.1.90.tab2_20July2012_Connected_Distance_SimNormal2to300_10Power6_BiasedSamplings.txt"));
				if(reps == 1000000){
					//if(randomized == true){
					//	out = new BufferedWriter(new FileWriter(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_SimNormal"+start+"to"+(end-1)+"_10Power6_12Mar13_Randomized_BiasedSamplings.txt"));
					//}
					//else{
					
						//Changed on 11/21/2014
						TPDSimNormalDistribution6 = "MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_SimNormal"+start+"to"+(end-1)+"_10Power6_nohub_top1percent_BiasedSamplings.txt";
						out = new BufferedWriter(new FileWriter(TPDSimNormalDistribution6));
						//out = new BufferedWriter(new FileWriter(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_SimNormal"+start+"to"+(end-1)+"_10Power6_nohub_top1percent_20Mar13_BiasedSamplings.txt"));
						
						
					//}
				}
				else if(reps == 100000){
					//if(randomized == true){
					//	out = new BufferedWriter(new FileWriter(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_SimNormal"+start+"to"+(end-1)+"_10Power5_12Mar13_Randomized_BiasedSamplings.txt"));
					//}else{
						
						//Changed on 11/21/2014
						TPDSimNormalDistribution5 = "MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_SimNormal"+start+"to"+(end-1)+"_10Power5_nohub_top1percent_BiasedSamplings.txt";
						out = new BufferedWriter(new FileWriter(TPDSimNormalDistribution5));
						//out = new BufferedWriter(new FileWriter(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_SimNormal"+start+"to"+(end-1)+"_10Power5_nohub_top1percent_20Mar13_BiasedSamplings.txt"));
						
						
					//}
				}
			}
			List<Double> distances = new ArrayList<Double>();
			for(int i = start; i < end; i++){
				System.out.println(i);
				//BufferedWriter outW = new BufferedWriter(new FileWriter("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormatDistanceSimSampling" + i + "toPlus1PowerMinus7Proteins.txt"));
				String s = in.readLine();
				String[] split = s.split(",");
				for(int j = 0; j < split.length; j++){
				//	outW.write(split[j] + ",");
				//	outW.flush();
					
					int numberWithD = 0;
					if(split[j].equalsIgnoreCase("0.0")){
						continue;
					}
					else{
						numberWithD = (int)(Double.parseDouble(split[j]) * reps);
					}
					for(int k = 0; k < numberWithD; k++){
						distances.add((double)j);
					}
				}
				//outW.close();
				double mean = 0.0;
				for(int j = 0; j < distances.size(); j++){
					mean = mean + distances.get(j);
				}
				mean = mean / distances.size();
					
				double sumSquared = 0.0; 
				double var = 0.0;
				for(int j = 0; j < distances.size(); j++){
					sumSquared = sumSquared + Math.pow(distances.get(j)-mean, 2);
				}
				sumSquared = Math.sqrt(sumSquared/distances.size());
				var = Math.pow(sumSquared, 2);
			
				distances.clear();
				

				
				boolean sawNonZero = false;
				//int comb = (int)MathUtils.binomialCoefficientDouble(i,2);
				double j = 0.00;
				while (true){
					double inc = (double)1/(double)roundFactor;
					double prob = (compNormalProb(mean,var,j)*inc);
						if (sawNonZero == false){
							if(prob > 0.0){
								sawNonZero = true;
							}
						}
						else{
							if(prob == 0.0){
								break;
							}
						}
						out.write(prob+",");
						out.flush();
						
						j = j + inc;
				}
				out.write("\n");
				out.flush();
				
				
			}
			out.close();
			
		}catch(Exception e){
			e.printStackTrace();
		}
	}

	
	private void simulateRealLife(int ps,List<Double> pathStats, int reps, String DataSet,/*Hashtable<String,Integer> proteinBiases,*/List<Integer> tokensForSampling, List<Pair<Protein,List<Protein>>> ProteinList, int pStart, int pEnd, int MotifSize, int UTRType, boolean randomized){
		try{
			Random rn = new Random();
			BufferedWriter out = null;
//			List<Integer> tokensForSampling = new ArrayList<Integer>();
			
			//Next to run
			int start = pStart;
			int end = pEnd;



			if(DataSet.equals("hupi")){
				//out = new BufferedWriter(new FileWriter("src/go/HuPIOriginalSimReal2toXXprotsWeightedSimP"+ stopProb + "RF"+roundFactor+"WMax500.txt"));
				//out = new BufferedWriter(new FileWriter("HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridConnectedMay1stDistanceSim2to100PowerMinus7Proteins.txt"));
				//out = new BufferedWriter(new FileWriter("BIOGRID_Yeast_3.1.90.tab2_20July2012_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power7Samplings.txt"));
				if(reps == 1000000){
//					if(randomized == true){
//						out = new BufferedWriter(new FileWriter(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power6_12Mar13_Randomized_BiasedSamplings.txt"));
//					}
//					else{
						//Changed on 11/21/2014
						TPDDistribution6 = "MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power6_nohub_top1percent_BiasedSamplings.txt";
						out = new BufferedWriter(new FileWriter(TPDDistribution6));
						//out = new BufferedWriter(new FileWriter(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power6_nohub_top1percent_20Mar13_BiasedSamplings.txt"));
//					}
				}else if (reps == 100000){
					//if(randomized == true){
					//	out = new BufferedWriter(new FileWriter(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power5_12Mar13_Randomized_BiasedSamplings.txt"));
					//}else{
					
						//Changed on 11/21/2014
						TPDDistribution5 = "MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power5_nohub_top1percent_BiasedSamplings.txt";
						out = new BufferedWriter(new FileWriter(TPDDistribution5));
						//out = new BufferedWriter(new FileWriter(Path+"Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim"+start+"to"+(end-1)+"_10Power5_nohub_top1percent_20Mar13_BiasedSamplings.txt"));
					//}
				}
				
			}
			else if(DataSet.equalsIgnoreCase("Collins")){
				out = new BufferedWriter(new FileWriter("src/go/CollinsConnectedSim2to300ProteinsP"+stopProb+"RF"+roundFactor+".txt"));
			}
			else if(DataSet.equals("krogan")){
				//out = new BufferedWriter(new FileWriter("src/go/KroganSimSimP"+ stopProb + "prots"+ i +"RF"+roundFactor+".txt"));
			}
			else if(DataSet.equals("Silico")){
				//out = new BufferedWriter(new FileWriter("src/go/SilicoSimSimP"+ stopProb + "prots"+ i +"RF"+roundFactor+".txt"));
			}
			
/*			for(int i = 0; i < ProteinList.size(); i++){
				if(proteinBiases.containsKey(ProteinList.get(i).first.getName())){
					int numberOfTokens = proteinBiases.get(ProteinList.get(i).first.getName());
					for(int j = 0; j < numberOfTokens; j++){
						tokensForSampling.add(i);
						
					}
				}
				
			}*/
			
			for(int i = start; i < end; i++){
				System.out.println("Subset Size =" + i);
				Map<Double,Double> numberWithDistance = new HashMap<Double, Double>();
				double biggestSim = 0.0;
				int counterIter = 0;
				for(int rep = 0; rep < reps; rep++){
				//	Key = totaldistance and object = number of times it appeared.
					HashSet<Integer> ProteinIndexSet = new HashSet<Integer>();
					for(int j = 0; j < i; j++){
						counterIter++;
						double r1 = rn.nextDouble();
						int tokeni = (int)Math.floor(r1*(tokensForSampling.size()));
//						System.out.println(tokeni);
//						System.out.println(tokensForSampling.size());
						int ind1 = tokensForSampling.get(tokeni);
						if(ProteinIndexSet.contains(ind1)){
							j--;
							
						}
						else{
							ProteinIndexSet.add(ind1);
						}
						
					}

					List<Integer> listProteinIndex = new ArrayList<Integer>();
					for(Integer intI: ProteinIndexSet){
						listProteinIndex.add(intI);
					}
					
					/*Change Start here*/
					double totalDistance = 0.0;
					int NumOfEntriesPerRow = (int)Math.round(0.1 * listProteinIndex.size());
					List<Double> RowDistances = new ArrayList<Double>();
					for(int j = 0; j < listProteinIndex.size(); j++){
						double RowDistance = 0.0;
						int[] distCount = new int[((int)largestEntryInMatrix+1)];
						for(int index = 0; index < distCount.length; index++){
							distCount[index] = 0;
						}
						for(int k = 0; k < listProteinIndex.size(); k++){
							distCount[(int)Dist[listProteinIndex.get(j)][listProteinIndex.get(k)]] = distCount[(int)Dist[listProteinIndex.get(j)][listProteinIndex.get(k)]] + 1;
							if(distCount[1] >= NumOfEntriesPerRow){
								break;
							}
						}
						
						
						int maxSizeToTake = 0;
						int sumOfEntries =0;
						for(int index = 1; index < distCount.length; index++){
							sumOfEntries = sumOfEntries + distCount[index];
							if(sumOfEntries >= NumOfEntriesPerRow){
								maxSizeToTake = index;
								break;
							}
						}
						
						if(sumOfEntries == NumOfEntriesPerRow){
							for(int index = 1; index <= maxSizeToTake; index++){
								RowDistance = RowDistance + (distCount[index]*index);
							}
						}
						else if(sumOfEntries > NumOfEntriesPerRow){
							int counterOfEntries = 0;
							for(int index = 1; index < maxSizeToTake; index++){
								RowDistance = RowDistance + (distCount[index]*index);
								counterOfEntries = counterOfEntries + distCount[index];
							}
							int entriesLeftToObtain = NumOfEntriesPerRow - counterOfEntries;
							RowDistance = RowDistance + (entriesLeftToObtain*maxSizeToTake);
						}
						else{
							System.out.println("Error in TPD calculation");
						}
						//System.out.println("RowDistances " + RowDistances);
						RowDistances.add(RowDistance);
					}

					Collections.sort(RowDistances);
					//if(RowDistances.size() != listProteinIndex.size()){
						//System.out.println("Error in TPD calculation 2");
					//}
					int tenPercent = NumOfEntriesPerRow;

					for(int index = 0; index < tenPercent; index++){
						//System.out.println("RowDistance ten percent " + RowDistances.get(index));
						totalDistance = totalDistance + RowDistances.get(index); 
					}

					//System.out.println("TotalDistance " + totalDistance);

					/*Change End here*/

					
					
/*					for(Integer p: listProteinIndex){
						for(Integer p2: listProteinIndex){
							if (p == p2){
								continue;
							}
							totalDistance = totalDistance + Dist[p][p2];
						}
					}
					totalDistance = totalDistance /2 ;
					
					totalDistance = totalDistance * roundFactor;*/
					
						
						
					totalDistance = (double)Math.round(totalDistance);
					if (totalDistance > biggestSim){
						biggestSim = totalDistance;
					}
					if (numberWithDistance.get(totalDistance) != null){
						numberWithDistance.put(totalDistance, numberWithDistance.get(totalDistance)+1);
					}
					
					else{
						numberWithDistance.put(totalDistance,1.0);
					}
				}
		
				System.out.println("Counter " + counterIter);
				
				for(double j = 0; j <= (int)(biggestSim); j++){
					if (numberWithDistance.get(j) == null){
						try{
							out.write("0.0,");
						}catch(Exception e){
							e.printStackTrace();
						}
					}
					else{
						try{
							double prob = numberWithDistance.get(j)/reps;	
							out.write(prob+",");
						}catch(Exception e){
							e.printStackTrace();
						}
					}
					
					out.flush();
				}
				out.write("\n");		
				out.flush();
				
			}
			out.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void computeProbMatrices(int pListSize, List<Double> pathStats, String DataSet){
		int numberOfProteinInSubset = 51;
		int lineLength = (int)((numberOfProteinInSubset*((roundFactor*largestEntryInMatrix)+1)));
		double AvgMatrix[][] = new double[numberOfProteinInSubset][lineLength];
		for(int i = 0; i < numberOfProteinInSubset; i++){
			for (int j = 0; j < lineLength; j++){
				AvgMatrix[i][j] = 0.0;
			}
		}
		try{
			List<List<Double>> statsForEachProteins = new ArrayList<List<Double>>();
			for(int i = 0; i < Dist.length; i++){
				double m[][] = new double[numberOfProteinInSubset][lineLength];
				System.out.println("Protein" + i);
				List<Double> dists = new ArrayList<Double>();
				dists.add(0.0);
				//1 = 0.001 
				//1000 = 1
				for(int a = 0; a <= (roundFactor*largestEntryInMatrix)+1; a++){
					dists.add(a,0.0);
				}
				//round 0.2345 = 234.5 = 235
				for (int j = 0; j < Dist.length; j++){			// loop a travers toute les proteins de la rangee donc toujours de 0 a < Dist.length
					int sim = (int)Math.round(Dist[i][j]*roundFactor);
					double toAdd = dists.get(sim)+1;
					dists.set(sim,toAdd);
				}										
				List<Double> distProbs = new ArrayList<Double>();
				distProbs.add(0.0);
				for (int a = 0; a <= (roundFactor*largestEntryInMatrix)+1; a++){			// loop a travers les distances possibles if round start a t 0 if ceil start at 1.
					distProbs.add(a,0.0);
				}
				for (int j = 0; j <= (roundFactor*largestEntryInMatrix)+1; j++){			// loop a travers les distances possibles if round start a t 0 if ceil start at 1.
					distProbs.add(j, (dists.get(j)/(Dist.length)));
				}
				statsForEachProteins.add(distProbs);
				List<Double> previous = new ArrayList<Double>();
				previous.addAll(distProbs);
				for(int l = 0; l <= (roundFactor*largestEntryInMatrix)+1; l++){
					m[1][l] = distProbs.get(l);
				}
				for (int e = 2; e < numberOfProteinInSubset; e++){
					List<Double> newList = new ArrayList<Double>();
					double sum = 0.0;
					for (int j = 0; j <= e*((roundFactor*largestEntryInMatrix)+1); j++){
						newList.add(0.0);
					}
					for(int j = 0; j <= e*((roundFactor*largestEntryInMatrix)+1); j++){
						double prob = 0.0;
						for (int d = 0; d <= ((roundFactor*largestEntryInMatrix)+1); d++){
							if (j-d > 0){
								double s = distProbs.get(d);
								double p = 0.0;
								if((j-d) < previous.size()){
									p = previous.get(j-d);
								}
								double mult = s*p;
								prob = prob + mult;
							}
						}
						sum = sum + prob;
						newList.add(j,prob);
					}
					previous.clear();
					previous.addAll(newList);
					for(int j = 0; j <= e*((roundFactor*largestEntryInMatrix)+1); j++){
						m[e][j] = newList.get(j);
					}
					newList.clear();
				}
				for(int index1 = 0; index1 < numberOfProteinInSubset; index1++){
					for (int index2 = 0; index2 < lineLength; index2++){
						AvgMatrix[index1][index2] =AvgMatrix[index1][index2]+m[index1][index2];
					}
				}
			}
			System.out.println("Hello!!!!!!");

			BufferedWriter avgXiEqB = null;
			if(DataSet.equals("hupi")){
				avgXiEqB = new BufferedWriter(new FileWriter("src/go/HuPIOriginalAvgRow2to50protsWeightedSimp" + stopProb + "RF"+roundFactor+"WMax500.txt"));
			}
			else if(DataSet.equals("krogan")){
				avgXiEqB = new BufferedWriter(new FileWriter("src/go/KroganAvgRowSimP"+ stopProb + "protsRF"+roundFactor+".txt"));
			}
			else if(DataSet.equals("Silico")){
				avgXiEqB = new BufferedWriter(new FileWriter("src/go/SilicoAvgRowSimP"+ stopProb + "protsRF"+roundFactor+".txt"));
			}
						
			for (int counter = 1; counter < numberOfProteinInSubset; counter++){
				double sumP = 0.0;
				for (int j = 0; j < lineLength; j++){
					AvgMatrix[counter][j] = AvgMatrix[counter][j]/(double)Dist.length;
					sumP = sumP + AvgMatrix[counter][j];
				}
				
				//Normalization
				for (int j = 0; j < lineLength; j++){
					avgXiEqB.write((AvgMatrix[counter][j]/sumP)+",");
				}
				avgXiEqB.write("\n");
				avgXiEqB.flush();
			}
			avgXiEqB.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return;
	}
	
	private void computeFinalRowProbMatrix(int pListSize, List<Double> pathStats, String DataSet){
		try{
			BufferedReader avgM = null;
			BufferedWriter finalTotalM = null;
			if(DataSet.equals("hupi")){
				avgM = new BufferedReader(new FileReader("src/go/HuPIOriginalAvgRow2to50protsWeightedSimp" + stopProb + "RF"+roundFactor+"WMax500.txt"));
				finalTotalM = new BufferedWriter(new FileWriter("src/go/HuPIRowConv2to50protsWeightedSimp" + stopProb + "RF"+roundFactor+"WMax500.txt"));
			}
			else if(DataSet.equals("krogan")){
				avgM = new BufferedReader(new FileReader("src/go/KroganAvgRowSimP"+ stopProb + "protsRF"+roundFactor+".txt"));
				finalTotalM = new BufferedWriter(new FileWriter("src/go/KroganRowConvSimP"+stopProb+"prots2to50RF"+roundFactor+"V2.txt"));
			}
			else if(DataSet.equals("Silico")){
				avgM = new BufferedReader(new FileReader("src/go/SilicoAvgRowSimP"+ stopProb + "protsRF"+roundFactor+".txt"));
				finalTotalM = new BufferedWriter(new FileWriter("src/go/SilicoRowConvSimP"+stopProb+"prots2to50RF"+roundFactor+".txt"));
			}
			
			String line = avgM.readLine();
			String[] probs = line.split(",");
			
			List<Double> previous = new ArrayList<Double>();
			double sumToNorm = 0.0;
			for(int i = 0; i < ((largestEntryInMatrix*roundFactor)+1); i++){				
				sumToNorm = Double.parseDouble(probs[i]) + sumToNorm;
			}
			for(int i = 0; i < ((largestEntryInMatrix*roundFactor)+1); i++){
				previous.add(Double.parseDouble(probs[i])/sumToNorm);
			}
			for (int i = 0; i < ((largestEntryInMatrix*roundFactor)+1); i++){
				finalTotalM.write(previous.get(i) + ",");
			}
			List<Double> avgPathStats = new ArrayList<Double>();
			avgPathStats.add(0.0);
			avgPathStats.addAll(previous);
			finalTotalM.write("\n");
			finalTotalM.flush();
			List<Double> newList = new ArrayList<Double>();
			for(int i = 3; i <= 50; i++){ // Number of paths within group of proteins
				System.out.println("Prob Num" + i);
				String l = avgM.readLine();
				String[] lsplit = l.split(",");
				List<Double> avgProbs = new ArrayList<Double>();
				for(int j = 0; j < lsplit.length; j++){
					avgProbs.add(Double.parseDouble(lsplit[j]));
				}
				int comb = (int)MathUtils.binomialCoefficientDouble((i),2);
				double zeroCounter = 0.0;
				boolean sawNumbers = false;
				for(int j = 0; j <= comb*((roundFactor*largestEntryInMatrix)+1); j++){ // Sum of the paths within the group of proteins
					double prob = 0.0;
					for(int beta = (i-1); beta <= (i-1)*((roundFactor*largestEntryInMatrix)+1); beta++){
						if (j-beta > 0){					
							double s = avgProbs.get(beta-(i-1));
							double p = 0.0;
							if ((j-beta) < previous.size()){
								p = previous.get(j-beta);
							}
							double mult = s*p;
							prob = prob + mult;
						}
					}
					if (prob != 0.0){
						sawNumbers = true;
					}
					if (prob == 0.0 && sawNumbers == true){
						zeroCounter++;
					}
					if(zeroCounter >= 100){
						break;
					}
					newList.add(j,prob);
				}
				if (i == 3){
					double sumN = 0.0;
					for(int k = 0; k < newList.size(); k++){
						sumN += newList.get(k);
					}
					for(int k = 0; k < newList.size(); k++){
						newList.set(k, (newList.get(k)/sumN));
					}
				}
				avgProbs.clear();
				previous.clear();
				previous.addAll(newList);
				for(int j = 0; j < newList.size(); j++){
					finalTotalM.write(newList.get(j) + ",");
					finalTotalM.flush();
				}
				finalTotalM.write("\n");
				finalTotalM.flush();
				newList.clear();
			}
			finalTotalM.close();
			
			
		}catch(Exception e){
			e.printStackTrace();
		}
		return;
	}
	
	private void computeProbMatrix(int listSize,List<Double> mean, List<Double> variance, List<Double> pathStats, String DataSet){
		try{
			BufferedWriter out = null;
			if(DataSet.equals("hupi")){
				//out = new BufferedWriter(new FileWriter("src/go/HuPINormalProbMatrix3to100prots"+stopProb + "RF" + roundFactor+ "_14Nov2010.txt"));
				out = new BufferedWriter(new FileWriter("src/go/HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridConnectedMay1stNormalProbMatrix3to100protsDistance_14Nov2010.txt"));
			}
			else if(DataSet.equals("krogan")){
//				out = new BufferedWriter(new FileWriter("src/go/KroganNormalSimP"+ stopProb + "prots" + i +"RF"+roundFactor+".txt"));
			}
			else if(DataSet.equals("Silico")){
//				out = new BufferedWriter(new FileWriter("src/go/SilicoNormalSimP"+ stopProb + "prots" + i +"RF"+roundFactor+".txt"));
			}
			else if(DataSet.equals("Collins")){
				out = new BufferedWriter(new FileWriter("src/go/CollinsConnectedNormal2to300ProteinsP"+stopProb + "RF" + roundFactor+ ".txt"));
			}
			else{
				System.out.println("ERROR********");
			}
			
			for(int i = 2; i < 101; i++){
				System.out.println(i);
				boolean sawNonZero = false;
				int comb = (int)MathUtils.binomialCoefficientDouble(i,2);
				double j = 0.00;
				while (j < (comb)){
					double inc = (double)1/(double)roundFactor;
					double prob = (compNormalProb(mean.get(i),variance.get(i),j)*inc);
					if (sawNonZero == false){
						if(prob > 0.0){
							sawNonZero = true;
						}
					}
					else{
						if(prob == 0.0){
							break;
						}
					}
					out.write(prob+",");
					out.flush();
					j = j + inc;
				}
				out.write("\n");
				out.flush();
				
			}
			out.flush();
			out.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private double compNormalProb(double mean, double variance, double j){
		double prob = 0.0;
		double s2Pi = Math.sqrt(2*Math.PI);
		double sd = Math.sqrt(variance);
		double exp = (-((j-mean)*(j-mean)))/(2*variance);
		prob = (1/(sd*s2Pi))*Math.pow(Math.E,exp);
		return prob;
	}
	
	private List<Double> computeMean(int lSize){
		List<Double> mean = new ArrayList<Double>();
		mean.add(0, -1.0);
		mean.add(1, -1.0);
		lSize = Dist.length;
		double MaxComb = (double)MathUtils.binomialCoefficientDouble(lSize,2);
		// k = number of protein
		for (int k = 2; k < 101; k++){
			double kComb = (double)MathUtils.binomialCoefficientDouble(k,2);
			double sum = 0.0;
			for(int i = 0; i < Dist.length; i++){
				for(int j = i+1; j < Dist.length; j++){
					sum = sum + Dist[i][j];
				}
			}
			System.out.println(((kComb/MaxComb)*sum));
			mean.add(k,((kComb/MaxComb)*sum));
		}
		return mean;
	}
	
	private List<Double> computeVariance(int lSize, List<Double> means){
		lSize = Dist.length;
		List<Double> variance = new ArrayList<Double>();
		variance.add(0, -1.0);
		variance.add(1, -1.0);
		double MaxComb2 = (double)MathUtils.binomialCoefficientDouble(lSize,2);
		double MaxComb3 = (double)MathUtils.binomialCoefficientDouble(lSize,3);
		double MaxCombMinus2 = (double)MathUtils.binomialCoefficientDouble((lSize-2),2);
		double expMSquared = 0.0;
		for (int i = 0; i < Dist.length; i++){
			for (int j = i+1; j < Dist.length; j++){
				expMSquared = expMSquared + Dist[i][j];
			}
		}
		double expM = expMSquared/(((Dist.length*Dist.length)/2)-Dist.length);
		expMSquared = Math.pow(expM, 2);
		for (int k = 2; k < 101; k++){
			double kComb2 = (double)MathUtils.binomialCoefficientDouble(k,2);
			double sum1 = 0.0;
			for(int i = 0; i < Dist.length; i++){
				for(int j = i+1; j < Dist.length; j++){
					sum1 = sum1 + (Dist[i][j]*Dist[i][j]);
				}
			}
			double firstTerm = ((kComb2/MaxComb2)*sum1);
			double sum2 = 0.0;
			double secondTerm = 0.0;
			double thirdTerm = 0.0;
			if (k>2){
				double kComb3 = (double)MathUtils.binomialCoefficientDouble(k,3);
				for(int i = 0; i < Dist.length; i++){
					for(int j = i+1; j < Dist.length; j++){
						for(int k2 = j+1; k2<Dist.length; k2++){
							sum2 = sum2 + ((Dist[i][j]*Dist[i][k2])+(Dist[i][j]*Dist[j][k2])+(Dist[i][k2]*Dist[j][k2]) );
						}
					}
				}
				secondTerm = (2*(kComb3/MaxComb3)*sum2);
				if (k > 3){
					double sum3 = 0.0;
					double kCombMinus2 = (double)MathUtils.binomialCoefficientDouble((k-2),2);
				
				// RIGHT WAY TO COMPUTE IT BUT VERY COMPUTATIONALY EXPENSIVE (O4)	
				/*	for(int i = 0; i < Dist.length; i++){
						for(int j = i+1; j < Dist.length; j++){
							for (int k2 = 0; k2 < Dist.length; k2++){
								for (int l = k2+1; l < Dist.length; l++ ){
									if((i != k2) && (i != l) && (j != k2) && (j != l)){
										sum3 = sum3 + (Dist[i][j]*Dist[l][k2]);
									}
								}
							}
						}
					}*/
				//	thirdTerm = (((kComb2*kCombMinus2)/(MaxComb2*MaxCombMinus2))*sum3);
				//	thirdTerm = (2*kComb2*kCombMinus2)*expMSquared;
					thirdTerm = (kComb2*kCombMinus2)*expMSquared;
					
				}
			}	
			double expSquared = (firstTerm+secondTerm+thirdTerm);
			double var = expSquared - Math.pow(means.get(k),2);
			variance.add(k,var);
			System.out.println(k);
			System.out.println("Third Term " + thirdTerm);
			System.out.println("Variance : " + var);
		}
		return variance;
	}
	
	private int findLargestPath(List<Double> pathStats){
		int i = 0;
		while(true){
			i++;
			if(pathStats.get(i)==0){
				break;
			}
		}
		return i-1; 
	}
	
	private List<Double> getStats(List<Pair<Protein,List<Protein>>> pList){
		List<Double> stats = new ArrayList<Double>();
		stats.add(0.0);
		double divider = 0.0;
		for (int l = 0; l <= (roundFactor*largestEntryInMatrix); l++){
			
			divider = 0.0;
			double counter = 0.0;
			for (int i = 0; i < pList.size(); i++){
				for(int j = i+1; j < pList.size(); j++){
					if(Math.round(Dist[i][j]*roundFactor) == l){
						counter++;
					}
					divider++;
				}
			}
			stats.add(l,(counter/divider));
		}
		System.out.println(stats);
		return stats;
	}
	
	private List<Double> getKroganStats(List<Pair<Protein,List<Protein>>> pList){
		List<Double> stats = new ArrayList<Double>();
		stats.add(0.0);
		double divider = 0.0;
		//divider = ((numProt*numProt)/2) - numProt;
		for (int l = 0; l < (largestEntryInMatrix+1); l++){
			double counter = 0.0;
			for (int i = 0; i < numProt; i++){
				for(int j = i+1; j < numProt; j++){
					if(Dist[i][j] == l){
						counter++;
					}
					divider++;
				}
			}
			stats.add(l,(counter/divider));
		}
		System.out.println(stats);
		return stats;
	}
	
	private void getKroganMatrix(List<Pair<Protein,List<Protein>>> pList){
		
		try{
			File MFile = new File("src/go/KroganTable7SubsetDistanceMatrix.txt");
			FileReader fRM = new FileReader(MFile);
			BufferedReader MReader = new BufferedReader(fRM);
			Dist = new double[numProt][numProt];
			int i = 0;
			String MLine = MReader.readLine();
			while (MLine != null){
				String[] t = MLine.split("t");
				for (int j = 0; j < numProt; j++){
					Dist[i][j]= Double.parseDouble(t[j]);
					if (Dist[i][j] > largestEntryInMatrix && Dist[i][j] != Double.MAX_VALUE){
						largestEntryInMatrix = Dist[i][j];
					}
				}
				i++;
				MLine = MReader.readLine();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	private void getMatrix(List<Pair<Protein,List<Protein>>> pList, int distanceMatrixType){
		Dist = new double[pList.size()][pList.size()];
		try{
			String s = null;
			File MFile = null;
			if ( distanceMatrixType == 0){
				
				//MFile = new File("HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridMay1stDistanceMatrixConnected_8Mai2010.txt");
				//MFile = new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_DistanceMatrixConnected.txt");
				MFile = new File(DistMatrixFileName);
				
				
				//MFile = new File("HuPIRelationsSimMatrixp" + stopProb + "k_14Nov2010.txt");
				//MFile = new File("src/go/HuPIOriginalDistMatrix.txt");
					
				//s = "CDK7";
				
				//MYPN
				s = firstGeneOnLastLine;
				System.out.println(firstGeneOnLastLine);
			}
				
			else if(distanceMatrixType == 1){
				if (stopProb == 0.1 || stopProb == 0.2){
					MFile = new File("src/go/KroganTable7SimMatrixp"+ stopProb +"0k150.txt");
				}
				else{
					MFile = new File("src/go/KroganTable7SimMatrixp"+ stopProb +"k150.txt");
				}
	//			s = "??????";
			}
			else if(distanceMatrixType == 2){
				//MFile = new File("src/go/ConnectedCollinsSimP0.15k150.txt");
				MFile = new File("src/go/CollinsConnectedSimMatrixp0.15k150.txt");
				s = "YFR052W";
				
			}
			else{
				return;
			}
			FileReader fRM = new FileReader(MFile);
			BufferedReader MReader = new BufferedReader(fRM);
			String MLine = MReader.readLine();
			int i = 0;
			while (MLine != null){
				System.out.println(MLine);
				String[] t = MLine.split("\t");
				if (t[0].equals(s)){
					break;
				}
				for (int j = 0; j < pList.size(); j++){
					System.out.println(t.length);
					Dist[i][j] = Double.parseDouble(t[j]);
					if (Dist[i][j] > largestEntryInMatrix){
						largestEntryInMatrix = Dist[i][j];
					}
					if (Math.round(Dist[i][j]*roundFactor) > MAX){
						MAX = Math.round(Dist[i][j]*roundFactor)+1;
					}
				}
				i++;
				MLine = MReader.readLine();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	
	
	
	private double computeAverageDistance(Set<Pair<Protein,List<Protein>>> pWithGo, List<Pair<Protein,List<Protein>>> pList){
		double avgDistance = 0.0;
		for (Pair<Protein,List<Protein>> p: pWithGo){
			for (Pair<Protein,List<Protein>> p2: pWithGo){
				avgDistance = avgDistance + getSimilarity(p.getf(),p2.getf(),pList);
			}
		}
		avgDistance = avgDistance / (pWithGo.size()*pWithGo.size()-pWithGo.size());
		return avgDistance;
	}
	
	private double getSimilarity(Protein p1, Protein p2, List<Pair<Protein,List<Protein>>> pList){
		int i = 0;
		for(Pair<Protein,List<Protein>> p: pList){
			if (p.getf().getName().equalsIgnoreCase(p1.getName())){
				break;
			}
			i++;
			
		}
		int j = 0;
		for(Pair<Protein,List<Protein>> p: pList){
			if (p.getf().getName().equalsIgnoreCase(p2.getName())){
				break;
			}
			j++;
			
		}
		return Dist[i][j];
	}
	
	private static List<Protein> createBaitList(List<Relation> relations){
		List<Protein> baits = new ArrayList<Protein>();
		for(Relation relation: relations){
			boolean found = false;
			for(Protein p: baits){
				if(relation.getBait().getName().equalsIgnoreCase(p.getName())){
					found = true;
				}
			}
			if(found == false){
				baits.add(relation.getBait());
			}
		}
		return baits;
	}
	
	private static List<Relation> createRelationListCollins(BufferedReader relationsReader){
		List<Relation> relations = new ArrayList<Relation>();
		try{
			String relationLine = relationsReader.readLine();
			relationLine = relationsReader.readLine();
			
			while (relationLine != null){
				String[] relationTokens = relationLine.split("\t");
				//Set<String> color = color(colorMap,relationTokens[0]);
				Set<String> blank = new HashSet<String>();
				Protein bait = new Protein(true,relationTokens[0],blank);
				//color = color(colorMap,relationTokens[1]);
				
				Protein target = new Protein(false,relationTokens[2],blank);
				Relation relation = new Relation(bait,target,0.0,0.0);
				relations.add(relation);
				relationLine = relationsReader.readLine();
			}
			
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return relations;
		
	}
	
	private static List<Relation> createRelationList(BufferedReader relationsReader){
		List<Relation> relations = new ArrayList<Relation>();
		try{
			String relationLine = relationsReader.readLine();
			boolean firstLine = true;
			while (relationLine != null){
				String[] relationTokens = relationLine.split("\t");
				if(relationTokens[15].equals("9606") && relationTokens[16].equals("9606")){
					//Set<String> color = color(colorMap,relationTokens[0]);
					Set<String> blank = new HashSet<String>();
					Protein bait = new Protein(true,relationTokens[7],blank);
					//color = color(colorMap,relationTokens[1]);
					if(firstLine){
						firstGeneOnLastLine = bait.getName();
						firstLine = false;
					}
					Protein target = new Protein(false,relationTokens[8],blank);
					//Double mascot = Double.parseDouble(relationTokens[2]);
					//Double iR = Double.parseDouble(relationTokens[4]);
					Relation relation = new Relation(bait,target,0.0,0.0);
					relations.add(relation);
				}
				relationLine = relationsReader.readLine();
			}
			
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return relations;
		
	}
	private static boolean isBait(String pName, List<Protein> baits){
		boolean isBait = false;
		for(Protein bait: baits){
			if(bait.getName().equalsIgnoreCase(pName)){
				isBait = true;
				break;
			}
		}
		return isBait;
	}
	private static List<Pair<Protein,List<Protein>>> createAdjacencyList(List<Relation> relations, List<Protein> baits){
		List<Pair<Protein,List<Protein>>> proteinList = new ArrayList<Pair<Protein,List<Protein>>>();
		for (Relation r: relations){
			String baitName = r.getBait().getName();
			String targetName = r.getTarget().getName();
			boolean foundBait = false;
			boolean foundTarget = false;
			for(Pair<Protein,List<Protein>> proteinNode: proteinList){
				if (proteinNode.getf().getName().equals(baitName)){
					boolean found = false;
					for (Protein p: proteinNode.gets()){
						if(p.getName().equalsIgnoreCase(targetName)){
							found = true;
						}
					}
					if (found == false){
						boolean isBait = isBait(targetName, baits);
						proteinNode.gets().add(new Protein(isBait,targetName,r.getTarget().getColor()));
					}
					foundBait = true;
				}
			}
			if (foundBait == false){
				boolean isBait = isBait(baitName, baits);
				Protein bait = new Protein(isBait,baitName,r.getBait().getColor());
				isBait = isBait(targetName, baits);
				Protein target = new Protein(isBait,targetName,r.getTarget().getColor());
				List<Protein> links = new ArrayList<Protein>();
				links.add(target);
				proteinList.add(new Pair<Protein,List<Protein>>(bait, links));
			}
			for(Pair<Protein,List<Protein>> proteinNode: proteinList){
				if (proteinNode.getf().getName().equals(targetName)){
					boolean found = false;
					for (Protein p: proteinNode.gets()){
						if(p.getName().equalsIgnoreCase(baitName)){
							found = true;
						}
					}
					if (found == false){
						boolean isBait = isBait(baitName, baits);
						proteinNode.gets().add(new Protein(isBait,baitName,r.getBait().getColor()));
					}
					foundTarget = true;
				}
			}
			if(foundTarget == false){
				boolean isBait = isBait(baitName, baits);
				Protein bait = new Protein(isBait,baitName,r.getBait().getColor());
				isBait = isBait(targetName, baits);
				Protein target = new Protein(isBait,targetName,r.getTarget().getColor());
				List<Protein> links = new ArrayList<Protein>();
				links.add(bait);
				proteinList.add(new Pair<Protein,List<Protein>>(target, links));
			}
		}

		return proteinList;
	}
	
	private List<Pair<Protein,List<Protein>>> readAdjacencyList(BufferedReader r){
		List<Pair<Protein,List<Protein>>> list = new ArrayList<Pair<Protein,List<Protein>>>();
		try{
			String s = r.readLine();
			while(s != null){
				String[] split = s.split(",");
				Protein p = new Protein(false,split[0],null);
				List<Protein> l = new ArrayList<Protein>();
				for(int i = 1; i < split.length; i++){
					Protein p2 = new Protein(false,split[i],null);
					l.add(p2);
				}
				Pair<Protein,List<Protein>> pair = new Pair(p,l);
				list.add(pair);
				s = r.readLine();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
		return list;
	}
	
	private Set<ANGeneSet> loadGeneSets(List<Pair<Protein,List<Protein>>> pList, BufferedReader in){
		Set<ANGeneSet> geneSets = new HashSet<ANGeneSet>();
		
		
		try{
			String s = in.readLine();
			int counter = 0;
			while(s != null){
				counter++;
				System.out.println(counter);
				String[] split = s.split("\t");
				if(split.length > 3){
					String geneSetName = split[0];
					List<String> GenesInGeneSet = new ArrayList<String>();
					List<Pair<Protein,List<Protein>>> subList = new ArrayList<Pair<Protein,List<Protein>>>();
					for(int i = 1; i < split.length; i++){
						GenesInGeneSet.add(split[i]);
					}
					for(String geneName: GenesInGeneSet){
						if (indices.containsKey(geneName)){
							int index = indices.get(geneName);
							Pair<Protein,List<Protein>> p = pList.get(index);
							subList.add(p);
						}
					}
					if(subList.size() > 2){
						ANGeneSet aGS = new ANGeneSet(subList, geneSetName);
						geneSets.add(aGS);
					}
				}
				s = in.readLine();
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		return geneSets;
	}
	
	
	private boolean sameNode(TreeNode n1, TreeNode n2){
		boolean same = false;
		for(Pair<Protein,List<Protein>> p1: n1.getProteins()){
			for(Pair<Protein,List<Protein>> p2: n2.getProteins()){
				if(p1.getf().getName().equals(p2.getf().getName())){
					same = true;
					break;
				}
			}
		}
		return same;
	}
	
	private void divideCluster(TreeNode root){
		if (root.getPvalue() > root.getChild1().getPvalue() || root.getPvalue() > root.getChild2().getPvalue() ){
			if (root.getChild1().getPvalue() < lessSignificantpValue){
				divideCluster(root.getChild1());
			}
			if (root.getChild2().getPvalue() < lessSignificantpValue){
				divideCluster(root.getChild2());
			}
		}
		else{
			significantGroups.add(root);
		}
	}
	
	//Changed on 11/21/2014
	//private Set<List<ANGeneSet>> findSignificantGeneSets(List<Pair<Protein,List<Protein>>> pList, String dataSet, BufferedReader in, BufferedWriter out, boolean KS, int MotifSize, int UTRType, boolean randomized, boolean compRandomized, List<String> motifToGetCores){
	private Set<List<ANGeneSet>> findSignificantGeneSets(List<Pair<Protein,List<Protein>>> pList, String dataSet, BufferedReader in, BufferedWriter out, boolean KS, int MotifSize, int UTRType, boolean randomized, boolean compRandomized, String folder){
	
		
	//private Set<List<ANGeneSet>> findSignificantGeneSets(List<Pair<Protein,List<Protein>>> pList, String dataSet, BufferedReader in, BufferedWriter out, boolean KS, int MotifSize, int UTRType, boolean randomized, boolean compRandomized, String firstLetter){
		
		Set<List<ANGeneSet>> goodGeneSets = new HashSet<List<ANGeneSet>>();
		BufferedWriter outP = null;
		BufferedWriter outCore = null;
		try{
			
			//Changed on 11/21/2014
			MotifCoreResultFile = folder+"/"+"ComplexeMotifs_MotifSize"+MotifSize+"_"+UTRType+"'UTR_MaxLength500_GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "Rand"+randomized+"CompleteRand" + compRandomized +"PvalueAssociation_SmallCore_ThresClust10-6.txt";
			outCore = new BufferedWriter(new FileWriter(new File(MotifCoreResultFile)));
			//outCore = new BufferedWriter(new FileWriter(new File(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500_GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "Rand"+randomized+"CompleteRand" + compRandomized +"PvalueAssociation_SmallCore_ThresClust10-6.txt")));
			
			
			//outP = new BufferedWriter(new FileWriter(new File(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500_GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "Rand"+randomized+"CompleteRand" + compRandomized +"PvalueAssociation_FirstLetter"+firstLetter+".txt")));
			//outP = new BufferedWriter(new FileWriter(new File(Path + "ComplexeMotifs_MotifSize"+MotifSize+"Biogrid"+UTRType+"'UTR_MaxLength500_GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To"+groupLimit+"andSimNormal10^5to" +maxGroupSize + "T" +lessSignificantpValue + "Rand"+randomized+"CompleteRand" + compRandomized +"PvalueAssociation.txt")));
		}catch (Exception e) {
			e.printStackTrace();
		}
		Random rn = new Random();
		int counter = 0;
		int numberOflessSignificantGeneSets = 0;
		int numberOfSignificantGeneSets = 0;
		int numberOfSignificantGeneSetsGood = 0;
		int numberOfSignificantGeneSetsBest = 0;
		int numberOfSignificantGeneSetsBetter = 0;
		int numberOfSignificantGeneSetsMuchBetter = 0;
		int numberOfSignificantGeneSetsVeryMuchBetter = 0;
		int numberOfSignificantGeneSetsUltimate = 0;
		int numberOfSignificantGeneSetsUltimate1 = 0;
		int numberOfSignificantGeneSetsUltimate2 = 0;
		int numberOfSignificantGeneSetsUltimate3 = 0;
		int numberOfSignificantGeneSetsUltimate4 = 0;
		int numberOfSignificantGeneSetsUltimate5 = 0;
		int numberOfSignificantGeneSetsUltimate6 = 0;
		int numberOfSignificantGeneSetsUltimate7 = 0;
		int numberOfSignificantGeneSetsUltimate8 = 0;

		int numberOfGeneSets = 0;
		
		//TOREMOVE
//		int maxlaoded = 500;
		//TOREMOVE
		
		System.out.println("Loading Sim P-values");
		List<List<Double>> allSimPValues = loadSimPValues(dataSet,MotifSize,UTRType,randomized);
		System.out.println("Loading Normal P-values");
		//TOCHANGE
		//List<List<Double>> allSimNormalPValues = loadSimNormalPValues(dataSet,maxlaoded);
		List<List<Double>> allSimNormalPValues = loadSimNormalPValues(dataSet,MotifSize,UTRType,randomized);
		//TOCHANGE
		try{
			String s = in.readLine();
			String s2 = null;
			if(KS){
				s2 = in.readLine();
			}
			while(s != null){
				counter++;
				System.out.println("GENE_SET " + counter);
				String[] split = s.split("\t");
				
				//TOREMOVE
				//if(split.length > maxlaoded+1 || split.length < 302){
				//	s = in.readLine();
				//	s2 = in.readLine();
				//	continue;
				//}
				//TOREMOVE
				
				//if(split[0].charAt(0) != firstLetter.charAt(0)){
				//	s = in.readLine();
				//	if(KS){
				//		s2 = in.readLine();
				//	}
				//	continue;
				//}
				
			
				if(split.length > 3){
					String geneSetName = split[0];
					//Changed on 11/21/2014
					//if(!motifToGetCores.contains(geneSetName)){
						s = in.readLine();
					//Changed on 11/21/2014
					//	continue;
					//Changed on 11/21/2014
					//}
					try{
						outCore.write(geneSetName+"\t");
					}catch (Exception e) {
						e.printStackTrace();
					}
//					List<String> AllGenesInGeneSet = new ArrayList<String>();
					List<String> GenesInGeneSet = new ArrayList<String>();
					List<Pair<Protein,List<Protein>>> subList = new ArrayList<Pair<Protein,List<Protein>>>();
					for(int i = 1; i < split.length; i++){
						GenesInGeneSet.add(split[i]);
//						AllGenesInGeneSet.add(split[i]);
					}
					for(String geneName: GenesInGeneSet){
						if (indices.containsKey(geneName)){
							int index = indices.get(geneName);
							Pair<Protein,List<Protein>> p = pList.get(index);
							subList.add(p);
						}
					}
					
					if(subList.size() > 4 && subList.size() <= maxGroupSize && subList.size() < (totalNumberOfProteins-1) ){ //4 because top 1 percent measure does not make sense below that 
						ANGeneSet gs = new ANGeneSet(subList, geneSetName);
						//geneSets.add(aGS);
						List<ANGeneSet> subGeneSets = new ArrayList<ANGeneSet>();
						if(gs.getProteins().size() > 4 /*&& gs.getProteins().size() <= groupLimit*/){ //4 because top 1 percent measure does not make sense below that
							numberOfGeneSets++;
				   				
				   				
								
								
								double globalPairwiseDistance = computeSumDistance(gs.getProteins(), pList,outCore);
								double globalSimpValue = 0.0;
								double globalSimNormalPValue = computeSimNormalPValue(gs.getProteins().size(), globalPairwiseDistance, allSimNormalPValues);
								double referencePvalue = 0.0;
								if(gs.getProteins().size() <= groupLimit){
									globalSimpValue = computeSimPValue(gs.getProteins().size(), globalPairwiseDistance, allSimPValues);
									if(globalSimpValue > 0.0){
										referencePvalue = globalSimpValue;
									}
									else{
										referencePvalue = globalSimNormalPValue;
									}
								
								}
								else{
									globalSimpValue = -1.0;
									referencePvalue = globalSimNormalPValue;
								}
								
								if(referencePvalue == 0.0){
									System.out.println("WARNING");
								}
	
								try{
				   				//	outP.write(geneSetName + "\t"+referencePvalue+"\n");
				   				//  outP.flush();
				   				}catch (Exception e) {
									e.printStackTrace();
								}
								if(referencePvalue < lessSignificantpValue){
									numberOflessSignificantGeneSets++;
									
									
									
									
									double dMax = 0.0;
							        //TO Uncomment FOR KS
									/*
									String[] split2 = s2.split("\t");
						   			
									
						   			
						   			int numberOfItems = split.length-1;
						   			
						   			List<Integer> positions = new ArrayList<Integer>();
						   			for(int i = 1; i < split2.length; i++){
						   				if(!split2[i].equals("0.0")){
						   					for(int j = 0; j < (int)Math.round(Double.parseDouble(split2[i]) * numberOfItems); j++){
						   						positions.add(i);
						   					}
						   				}
						   			}
						   			
						   			Collections.sort(positions);
						   			
						   			double fraction = 1.0/(double)numberOfItems;
					   				double dMax = 0.0;
					   				double uniformValue = 0.0;
					   				for(int j = 0; j < positions.size(); j++){
					   					//Problem here
					   					uniformValue = cumulValueUniform1to1000(positions.get(j));
					   					double d = Math.abs(j*fraction - uniformValue);
					   					if(d > dMax){
					   						dMax = d; 
					   					}
					   					
					   					d = Math.abs(((j+1)*fraction) - uniformValue);
					   					if(d > dMax){
					   						dMax = d; 
					   					}
					   				}
					   				*/
					   				
					   				System.out.println("Check Speed #1 End");
					   				
					   				if(referencePvalue < significantpValue){
					   					numberOfSignificantGeneSets++;
					   				
									if(referencePvalue < significantpValueGood){
										numberOfSignificantGeneSetsGood++;
										if(referencePvalue < significantpValueBest){
											numberOfSignificantGeneSetsBest++;
											if(referencePvalue < significantpValueBetter){
												numberOfSignificantGeneSetsBetter++;
												if(referencePvalue < significantpValueMuchBetter){
													numberOfSignificantGeneSetsMuchBetter++;
													if(referencePvalue < significantpValueVeryMuchBetter){
														numberOfSignificantGeneSetsVeryMuchBetter++;
														if(referencePvalue < significantpValueUltimate){
															numberOfSignificantGeneSetsUltimate++;
															if(referencePvalue < significantpValueUltimate1){
																numberOfSignificantGeneSetsUltimate1++;
																if(referencePvalue < significantpValueUltimate2){
																	numberOfSignificantGeneSetsUltimate2++;
																	if(referencePvalue < significantpValueUltimate3){
																		numberOfSignificantGeneSetsUltimate3++;
																		if(referencePvalue < significantpValueUltimate4){
																			numberOfSignificantGeneSetsUltimate4++;
																			if(referencePvalue < significantpValueUltimate5){
																				numberOfSignificantGeneSetsUltimate5++;
																				if(referencePvalue < significantpValueUltimate6){
																					numberOfSignificantGeneSetsUltimate6++;
																					if(referencePvalue < significantpValueUltimate7){
																						numberOfSignificantGeneSetsUltimate7++;
																						if(referencePvalue < significantpValueUltimate8){
																							numberOfSignificantGeneSetsUltimate8++;
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
					   				}
									
									double globalUpperpValue = -1.0;
									double globalLowerpValue = -1.0;
									double globalTriRoundpValue = -1.0;
									//globalUpperpValue = computeUpperPValue(gs.getProteins().size(),globalPairwiseDistance,dataSet);
									if(!dataSet.equalsIgnoreCase("Collins") && !dataSet.equalsIgnoreCase("hupi") ){	
										globalLowerpValue = -1.0;
										if (gs.getProteins().size() < 51){
											globalLowerpValue = computeLowerPValue(gs.getProteins().size(),globalPairwiseDistance,dataSet);
										}
										globalTriRoundpValue = -1.0; 
										if (gs.getProteins().size() < 13){
											globalTriRoundpValue = computeTriRoundPValue(gs.getProteins().size(), globalPairwiseDistance,dataSet); 
										}
									}
									
									double globalAvgD = ((double)(globalPairwiseDistance*2)/(double)gs.getProteins().size())/((double)gs.getProteins().size()-1);
									
	/*								if(gs.getProteins().size() > 289){
										System.out.println("Hello");
										outSuper.write("Motif: " + gs.getGeneSetName() + "\n");
										outSuper.write("Number of Proteins: " +gs.getProteins().size()+ "\n");
										outSuper.write("Global Pairwise Distance: " + globalPairwiseDistance+ "\n");
										outSuper.write("Average Distance for a proteins to the others: " + globalAvgD+ "\n");
										outSuper.write("Estimated p-value: " + globalSimpValue+ "\n");
										//outSuper.write("===================================");
										outSuper.flush();
									}*/
									
									//TO Uncomment FOR KS
									double KSPvalue = -1.0;
									//double KSPvalue = getPvalueFromDvalue(gs.getProteins().size(), dMax);
									
									gs.setTotalD(globalPairwiseDistance);
									gs.setAvgD(globalAvgD);
									gs.setSimPvalue(globalSimpValue);
									gs.setUpperPvalue(globalUpperpValue);
									gs.setLowerPValue(globalLowerpValue);
									gs.setTriRound(globalTriRoundpValue);
									gs.setTriInterpol(-1.0);
									gs.setRefPValue(referencePvalue);
									gs.setSimNormalPvalue(globalSimNormalPValue);
									gs.setDMax(dMax);
									gs.setKSPvalue(KSPvalue);
									subGeneSets.add(gs);
									
									
									out.write("Motif=" + gs.getGeneSetName()+"\n");
									out.write("Average Distance: " + gs.getAvgD() + "\n");
							        out.write("Total Distance: " + gs.getTotalD() + "\n");
							        out.write("Reference p-Value : " + gs.getRefPValue() + "\n");
							        out.write("Normal Sim approximation p-Value : " + gs.getSimNormalPValue() + "\n");
							        out.write("Normal approximation p-Value : " + gs.getUpperPValue() + "\n");
							        //out.write("Y-convolution p-Value : " + gs.getLowerPValue() + "\n");
							        //out.write("Triangle decomposition (rounding) p-Value : " + gs.getTRPValue() + "\n");
							        //out.write("Triangle decomposition (Interpol) p-Value : " + gs.getTInterpolPValue() + "\n");
							        out.write("Monte-Carlo Estimation p-Value : " + gs.getSimPValue() + "\n");
							        out.write(gs.getProteins().size() + " Proteins with this annotation\n" );
							        //out.write("Dmax : " + gs.getDMax() + "\tK-S Pvalue " + gs.getKSPvalue());
							        if(gs.getKSPvalue() < 0.05 && gs.getKSPvalue() != -1.0){
							        	out.write("\t#######NON-UNIFORM########\n");
							        }
							        else{
							        	out.write("\n");
							        }
							        
							        for(Pair<Protein, List<Protein>> p: gs.getProteins()){
							        	out.write(p.getf().getName()+ "\n");
							        }
							        	
							        //out.write(".................................\n");
							        out.flush();
							        
							        out.write("====================\n");
							        out.flush();
									
							        //TO Uncomment FOR KS
									/*
									
									System.out.println("Check Speed");
									TreeNode root = buildTree(gs,pList, allSimPValues, allSimNormalPValues);
									System.out.println("Check Speed 2");
									significantGroups.clear();
									divideCluster(root);
									for (TreeNode n: significantGroups){
										List<Pair<Protein,List<Protein>>> subSetProteins = new ArrayList<Pair<Protein,List<Protein>>>();
										for (Pair<Protein,List<Protein>> p: n.getProteins()){
											subSetProteins.add(p);
										}
										ANGeneSet subGeneSet = new ANGeneSet(subSetProteins,gs.getGeneSetName());
										double sumDistance = n.getPairwiseDistance();
										double upperpValue = -1.0;
	
										
										double simpValue = 0.0;
										double simNormalPValue = computeSimNormalPValue(n.getProteins().size(), sumDistance, allSimNormalPValues);
										double subReferencePvalue = 0.0;
										if(n.getProteins().size() <= groupLimit){
											simpValue = computeSimPValue(n.getProteins().size(), sumDistance, allSimPValues);
											if(simpValue > 0.0){
												subReferencePvalue = simpValue;
											}
											else{
												subReferencePvalue = simNormalPValue;
											}
										}
										else{
											globalSimpValue = -1.0;
											subReferencePvalue = simNormalPValue;
										}
	
										double lowerpValue = -1.0;
										if(!dataSet.equalsIgnoreCase("Collins") && !dataSet.equalsIgnoreCase("hupi")){
											if(n.getProteins().size() < 51){
												lowerpValue = computeLowerPValue(n.getProteins().size(),sumDistance,dataSet);
											}
										}
										double triRound = -1.0;
										if(!dataSet.equalsIgnoreCase("Collins") && !dataSet.equalsIgnoreCase("hupi") ){
											if(n.getProteins().size() < 13){
												triRound = computeTriRoundPValue(n.getProteins().size(),sumDistance,dataSet);
											}
										}
					//					double triInterpol = computeTriInterpolPValue(n.getProteins().size(),sumDistance,dataSet);
										double avgD = ((double)(sumDistance*2)/(double)n.getProteins().size())/((double)n.getProteins().size()-1);
										if (subReferencePvalue <= significantpValue){
											subGeneSet.setTotalD(sumDistance);
											subGeneSet.setAvgD(avgD);
											subGeneSet.setSimPvalue(simpValue);
											subGeneSet.setUpperPvalue(upperpValue);
											subGeneSet.setLowerPValue(lowerpValue);
											subGeneSet.setTriRound(triRound);
											subGeneSet.setTriInterpol(-1.0);
											subGeneSet.setSimNormalPvalue(simNormalPValue);
											subGeneSet.setRefPValue(subReferencePvalue);
											subGeneSets.add(subGeneSet);
										}
									}
									if(subGeneSets.size() > 1){
									//	goodGeneSets.add(subGeneSets);
									
									
									    
									    //BufferedWriter out = new BufferedWriter(new FileWriter("src/go/HuPIOriginalGoGroupsGreedyImprovedWeightedDistanceWMax100.txt"));
								        for(ANGeneSet ANgs: subGeneSets){
									        out.write("Gene Set : " + ANgs.getGeneSetName() + ", Average Distance: " + ANgs.getAvgD() + "\n");
									        out.write("Total Distance: " + ANgs.getTotalD() + "\n");
									        out.write("Reference p-Value : " + ANgs.getRefPValue() + "\n");
									        out.write("Normal Sim approximation p-Value : " + ANgs.getSimNormalPValue() + "\n");
									        out.write("Normal approximation p-Value : " + ANgs.getUpperPValue() + "\n");
									        out.write("Y-convolution p-Value : " + ANgs.getLowerPValue() + "\n");
									        out.write("Triangle decomposition (rounding) p-Value : " + ANgs.getTRPValue() + "\n");
									        out.write("Triangle decomposition (Interpol) p-Value : " + ANgs.getTInterpolPValue() + "\n");
									        out.write("Monte-Carlo Estimation p-Value : " + ANgs.getSimPValue() + "\n");
									        out.write(ANgs.getProteins().size() + " Proteins with this GO Function\n" );
									        out.write("Dmax : " + ANgs.getDMax() + "\tK-S Pvalue " + ANgs.getKSPvalue());
									        if(ANgs.getKSPvalue() < 0.05 && ANgs.getKSPvalue() != -1.0){
									        	out.write("\t#######NON-UNIFORM########\n");
									        }
									        else{
									        	out.write("\n");
									        }
									        
									        for(Pair<Protein, List<Protein>> p: ANgs.getProteins()){
									        	out.write(p.getf().getName()+ "\n");
									        }
									        	
									        out.write(".................................\n");
									        out.flush();
								        }
								        out.write("============================================================\n" +
								        			"=========================================================\n");
								        out.flush();
									}*/
							
								}
								
						}
											
					}
					else{
						//Added 31 March 2016
						outCore.write("\n");
						outCore.flush();
					}
				}
				s = in.readLine();
				if(KS){
					s2 = in.readLine();
				}
			}
        	out.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println("Number of Gene Sets Tested: " + numberOfGeneSets);
		System.out.println("Number of significant Gene sets with p-value less than" + lessSignificantpValue + ": "+numberOflessSignificantGeneSets);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValue + ": "+numberOfSignificantGeneSets);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueGood + ": "+numberOfSignificantGeneSetsGood);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueBest + ": "+numberOfSignificantGeneSetsBest);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueBetter + ": "+numberOfSignificantGeneSetsBetter);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueMuchBetter + ": "+numberOfSignificantGeneSetsMuchBetter);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueVeryMuchBetter + ": "+numberOfSignificantGeneSetsVeryMuchBetter);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate + ": "+numberOfSignificantGeneSetsUltimate);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate1 + ": "+numberOfSignificantGeneSetsUltimate1);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate2 + ": "+numberOfSignificantGeneSetsUltimate2);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate3 + ": "+numberOfSignificantGeneSetsUltimate3);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate4 + ": "+numberOfSignificantGeneSetsUltimate4);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate5 + ": "+numberOfSignificantGeneSetsUltimate5);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate6 + ": "+numberOfSignificantGeneSetsUltimate6);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate7 + ": "+numberOfSignificantGeneSetsUltimate7);
		System.out.println("Number of significant Gene sets with p-value less than" + significantpValueUltimate8 + ": "+numberOfSignificantGeneSetsUltimate8);
		try{
		//	outP.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
				
		return goodGeneSets;
	}

	
	
	
	private double computeLowerPValue(int numProteins,double sim,String dataSet){
		double pValue = 0.0;
		try{
			BufferedReader in =null;
			if (dataSet.equals("krogan")){
				in = new BufferedReader(new FileReader(new File("src/go/kroganYConvolution.txt")));
			}
			else if(dataSet.equals("hupi")){
				in = new BufferedReader(new FileReader(new File("src/go/HuPIRowConv2to50protsWeightedSimp0.15RF1000.0WMax500.txt")));
			}
			String line = in.readLine();
						
			for(int i = 2; i < numProteins; i++){
				line = in.readLine();
			}
			String[] l = line.split(",");
			for(int i = (l.length-1); i >= (Math.round(sim*roundFactor)); i--){
				pValue = pValue + Double.parseDouble(l[i]);
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return pValue;
	}
	
	private double computeUpperPValue(int numProteins,double sim,String dataSet){
		double pValue = 0.0;
		try{
			BufferedReader in =null;
			if (dataSet.equals("krogan")){
				in = new BufferedReader(new FileReader(new File("src/go/KroganNormalProbMatrix3to100protsP.txt")));
			}
			else if (dataSet.equals("hupi")){
				in = new BufferedReader(new FileReader(new File("src/go/HuPINormalProbMatrix3to100protsDistance_14Nov2010.txt")));
			}
			else if (dataSet.equals("Collins")){
				in = new BufferedReader(new FileReader(new File("src/go/CollinsConnectedNormal2to300ProteinsP"+stopProb + "RF" + roundFactor+ ".txt")));
			}
			String line = in.readLine();
			for(int i = 3; i < numProteins; i++){
				line = in.readLine();
			}
			String[] l = line.split(",");
			//for(int i = (l.length-1); i >= Math.round(sim*roundFactor); i--){
			for(int i = (int)Math.round(sim*roundFactor); i <= (l.length-1); i++){
				pValue = pValue + Double.parseDouble(l[i]);
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return pValue;
	}
	
/*	private TreeNode buildTree(ANGeneSet gs,List<Pair<Protein,List<Protein>>> pList, List<List<Double>> allSimPValues, List<List<Double>> allSimNormalPValues){
		//TreeNode(TreeNode pParent, TreeNode pChild1, TreeNode pChild2, Set<Pair<Protein,List<Protein>>> pProteins,double pPvalue){
		TreeNode root = null;
		Set<TreeNode> clusters = new HashSet<TreeNode>();
		for(Pair<Protein,List<Protein>> protein: gs.getProteins()){
			List<Pair<Protein,List<Protein>>> nodes = new ArrayList<Pair<Protein,List<Protein>>>();
			nodes.add(protein);
			List<Integer> index = new ArrayList<Integer>();
			index.add(indices.get(protein.getf().getName()));
			TreeNode n = new TreeNode(null,null,null,nodes,1.0,index,0);
			clusters.add(n);
		}
		
				
		int proteinNumber = clusters.size();
		boolean rootCreated = false;
		while(!rootCreated){
			double maxSim = Double.MAX_VALUE;
			TreeNode maxNode1 = null;
			TreeNode maxNode2 = null;
			for(TreeNode n1: clusters){
				if (!n1.isInTree()){
					for(TreeNode n2: clusters){
						if (!n2.isInTree()){
							if (!sameNode(n1,n2)){
								double sim = getAverageDistance(n1, n2);
								if (sim < maxSim){
									maxSim = sim;
									maxNode1 = n1;
									maxNode2 = n2;
								}
							}
						}
					}
				}
			}

			List<Pair<Protein,List<Protein>>> mergedList = new ArrayList<Pair<Protein,List<Protein>>>();
			mergedList.addAll(maxNode1.getProteins());
			mergedList.addAll(maxNode2.getProteins());
			List<Integer> indexes = new ArrayList<Integer>();
			indexes.addAll(maxNode1.getIndexes());
			indexes.addAll(maxNode2.getIndexes());
			List<Pair<Protein,List<Protein>>> mergedSet = new ArrayList<Pair<Protein,List<Protein>>>();
			for(Pair<Protein,List<Protein>> pair: mergedList){
				mergedSet.add(pair);
			}
		
			double pairwiseDistance = computeSumDistance(mergedSet,pList);
			
			double globalSimpValue;
			double globalSimNormalPValue = computeSimNormalPValue(mergedSet.size(), pairwiseDistance, allSimNormalPValues);
			double referencePvalue;
			if(mergedSet.size() <= groupLimit){
				globalSimpValue = computeSimPValue(mergedSet.size(), pairwiseDistance,allSimPValues);
				if(globalSimpValue > 0.0){
					referencePvalue = globalSimpValue;
				}
				else{
					referencePvalue = globalSimNormalPValue;
				}
			}
			else{
				globalSimpValue = -1.0;
				referencePvalue = globalSimNormalPValue;
			}

			//double pValue = computeUpperPValue(mergedSet.size(), pairwiseDistance, dataSet);
			//double pValue = computeSimPValue(mergedSet.size(),pairwiseDistance,allSimPValues);
			
			
		
			TreeNode merged = new TreeNode(null,maxNode1,maxNode2,mergedList,referencePvalue,indexes,pairwiseDistance);
			clusters.add(merged);
			
			maxNode1.InTree();
			maxNode2.InTree();
			if (mergedSet.size() == proteinNumber){
				rootCreated = true;
			}
			root = merged;
		}
		return root;
	}*/

	
	private List<List<Double>>  loadSimNormalPValues(String dataSet, int MotifSize, int UTRType, boolean randomized){
		//TO REMOVE
		//int counterToMax =0;
		//TO REMOVE
		List<List<Double>> allPValues = new ArrayList<List<Double>>();
		allPValues.add(new ArrayList<Double>()); //index 0
		allPValues.add(new ArrayList<Double>()); //index 1
		allPValues.add(new ArrayList<Double>()); //index 2
		allPValues.add(new ArrayList<Double>()); //index 3
		allPValues.add(new ArrayList<Double>()); //index 4
		//TO REMOVE
		//counterToMax++;
		//TO REMOVE
		BufferedReader in = null; 
		try{
			if (dataSet.equals("krogan")){
				in = new BufferedReader(new FileReader(new File("src/go/KroganSimReal2to98protsDistance.txt")));
			}
			else if (dataSet.equals("hupi")){
				
				//in = new BufferedReader(new FileReader(new File("HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridConnectedMay1stDistanceSim2to100PowerMinus7Proteins.txt")));
				//in = new BufferedReader(new FileReader(new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormatDistanceSim2to299PowerMinus7Proteins.txt")));
				//in = new BufferedReader(new FileReader(new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormatDistanceNormalApprox2to999PowerMinus5ProteinsV2.txt")));
				//in = new BufferedReader(new FileReader(new File("BIOGRID_Yeast_3.1.90.tab2_20July2012_Connected_Distance_SimNormal2to1000_10Power6_for2to300_and5_for301to1000_BiasedSamplings.txt")));
				//if(randomized == true){
				//	in = new BufferedReader(new FileReader(new File(Path + "HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogrid_11July2012_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_SimNormal2to1000_10Power6_for2to300_and5_for301to1000_20Feb2013_Randomized_BiasedSamplings.txt")));
				//}else{													
					
				
					//Changed on 11/21/2014
					//in = new BufferedReader(new FileReader(new File(Path + "Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_SimNormal5to1500_10Power6_for5to300_and5_for301to1500_nohub_top1percent_20Mar2013_BiasedSamplings.txt")));
					in = new BufferedReader(new FileReader(new File(MergedTPDSimNormalDistribution)));
					
				//}
			}
			else if (dataSet.equalsIgnoreCase("Collins")){
				in = new BufferedReader(new FileReader(new File("src/go/CollinsConnectedSim2to300ProteinsP"+stopProb+"RF"+roundFactor+".txt")));
			}
			String line = in.readLine();
			int counter = 0;
			while(line != null){
				
				
				//TO REMOVE
				//counterToMax++;

				//if(counterToMax < 301){
				//	allPValues.add(new ArrayList<Double>());
				//	line = in.readLine();
				//	continue;
				//}
				//if(counterToMax > max){
				//	break;
				//}
				//TO REMOVE
				
				counter++;
				System.out.println(counter);
				List<Double> pValues = new ArrayList<Double>();
				String[] l = line.split(",");
				double pValue = 0.0;
				for(int i = 0; i < l.length; i++){
					pValues.add(pValue + Double.parseDouble(l[i]));
					pValue = pValues.get(i);
				}
				allPValues.add(pValues);
				line = in.readLine();
				if(counter ==  (maxGroupSize-1)){
					break;
				}
			}
			in.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
		return allPValues;
	}
	
	private List<List<Double>> loadSimPValues(String dataSet, int MotifSize, int UTRType, boolean randomized){
		List<List<Double>> allPValues = new ArrayList<List<Double>>();
		allPValues.add(new ArrayList<Double>()); //index 0
		allPValues.add(new ArrayList<Double>()); //index 1
		allPValues.add(new ArrayList<Double>()); //index 2
		allPValues.add(new ArrayList<Double>()); //index 3
		allPValues.add(new ArrayList<Double>()); //index 4
		BufferedReader in = null; 
		
		try{
			if (dataSet.equals("krogan")){
				in = new BufferedReader(new FileReader(new File("src/go/KroganSimReal2to98protsDistance.txt")));
			}
			else if (dataSet.equals("hupi")){
				
				//in = new BufferedReader(new FileReader(new File("HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogridConnectedMay1stDistanceSim2to100PowerMinus7Proteins.txt")));
				//in = new BufferedReader(new FileReader(new File("BIOGRID-ORGANISM-Saccharomyces_cerevisiae-3.1.79.tab2_ConnectedSimpleFormatDistanceSim2to299PowerMinus7Proteins.txt")));
				//in = new BufferedReader(new FileReader(new File("BIOGRID_Yeast_3.1.90.tab2_20July2012_Connected_Distance_Sim2to300_10Power6_BiasedSamplings.txt")));
//				if(randomized){
//					in = new BufferedReader(new FileReader(new File(Path+ "HuPIHighConfidenceFDR0.1_14Nov2010WithCompleteBiogrid_11July2012_MotifSize"+MotifSize+"_UTR"+UTRType+"_Connected_Distance_Sim2to300_10Power6_20Feb2013_Randomized_BiasedSamplings.txt")));
//				}
//				else{
					
					//Changed on 11/21/2014
					//in = new BufferedReader(new FileReader(new File(Path+ "Biogrid_28Fev13_MotifSize"+MotifSize+"_UTR"+UTRType+"_UTRLength500_Connected_Distance_Sim5to300_10Power6_nohub_top1percent_20Mar13_BiasedSamplings.txt")));
					in = new BufferedReader(new FileReader(new File(MergedTPDDistribution)));
					
//				}
				
			}
			else if (dataSet.equalsIgnoreCase("Collins")){
				in = new BufferedReader(new FileReader(new File("src/go/CollinsConnectedSim2to300ProteinsP"+stopProb+"RF"+roundFactor+".txt")));
			}
			String line = in.readLine();
			int counter = 0;
			while(line != null){
				counter++;
				List<Double> pValues = new ArrayList<Double>();
				String[] l = line.split(",");
				double pValue = 0.0;
				for(int i = 0; i < l.length; i++){
					pValues.add(pValue + Double.parseDouble(l[i]));
					pValue = pValues.get(i);
				}
					
				
				allPValues.add(pValues);
				line = in.readLine();
			}
			in.close();
		}catch (Exception e) {
			e.printStackTrace();
		}
		return allPValues;
	}
	
	private double computeSimPValue(int numProteins,double sim, List<List<Double>> allPValues){
		System.out.println(numProteins);
		System.out.println(sim);
		System.out.println((int)sim);
		System.out.println(allPValues.get(numProteins).size());
		if(sim >= allPValues.get(numProteins).size()){
			return 1.0;
		}
		else{
			
			return allPValues.get(numProteins).get((int)sim);
		}
	}
	
	private double computeSimNormalPValue(int numProteins, double globalPairwiseDistance, List<List<Double>> allPValues){
		
		if(globalPairwiseDistance > allPValues.get(numProteins).size()){
			return 1.0;
		}
		else{
			return allPValues.get(numProteins).get((int)globalPairwiseDistance);
		}
	}
	
	private double computeTriRoundPValue(int numProteins,double sim,String dataSet){
		double pValue = 0.0;
		try{
			BufferedReader in =null; 
			if (dataSet.equals("krogan")){
				in = new BufferedReader(new FileReader(new File("src/go/" + dataSet + "TriangleEstimatorDist_protsRound.txt")));
			}
			else if (dataSet.equals("hupi")){
				in = new BufferedReader(new FileReader(new File("src/go/HuPIRelationsTri3to12protsWeightedSimRoundp0.15RF1000.0WMax500.txt")));
			}
			String line = in.readLine();
			
			for(int i = 3; i < numProteins; i++){
				line = in.readLine();
			}
			
			String[] l = line.split(",");
			for(int i = (l.length-1); i >= Math.round(sim*roundFactor); i--){
				pValue = pValue + Double.parseDouble(l[i]);
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return pValue;
	}
	private double computeTriInterpolPValue(int numProteins,double distance,String dataSet){
		double pValue = 0.0;
		try{
			BufferedReader in =null; 
			if (dataSet.equals("krogan")){
				in = new BufferedReader(new FileReader(new File("src/go/" + dataSet + "TriangleEstimatorDist_protsInterpol.txt")));
			}
			else if (dataSet.equals("hupi")){
				in = new BufferedReader(new FileReader(new File("src/go/" + dataSet + "TriangleEstimatorDist_protsInterpol.txt")));
			}
			String line = in.readLine();
			for(int i = 3; i < numProteins; i++){
				line = in.readLine();
			}
			
			String[] l = line.split(",");
			for(int i = 0; i <= (distance-1); i++){
				pValue = pValue + Double.parseDouble(l[i]);
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return pValue;
	}

	private double computeSumDistance(List<Pair<Protein,List<Protein>>> pWithGo, List<Pair<Protein,List<Protein>>> pList, BufferedWriter outCore){
/*		double sumDistance = 0.0;
		for (int i = 0; i < pWithGo.size(); i++){
			Pair<Protein,List<Protein>> p = pWithGo.get(i);
			for (int j = i+1; j < pWithGo.size(); j++){
				Pair<Protein,List<Protein>> p2 = pWithGo.get(j);
				sumDistance = sumDistance + getDistance(p.getf(),p2.getf(),pList);
			}
		}*/
		
		/*Change Start here*/
		double sumDistance = 0.0;
		int NumOfEntriesPerRow = (int)Math.round(0.1 * pWithGo.size()); //10 percent of the total number of proteins in GeneSet
		List<Double> RowDistances = new ArrayList<Double>(); //Storing row distances
		HashMap<String,Double> geneRowDist = new HashMap<String, Double>();
		for(int i = 0; i < pWithGo.size(); i++){ //looping through proteins in gene set
			Pair<Protein,List<Protein>> p = pWithGo.get(i); 
			double RowDistance = 0.0;
			int[] distCount = new int[((int)largestEntryInMatrix+1)];
			for(int index = 0; index < distCount.length; index++){
				distCount[index] = 0;
			}
			for(int k = 0; k < pWithGo.size(); k++){
				Pair<Protein,List<Protein>> p2 = pWithGo.get(k);
				distCount[(int)getDistance(p.getf(),p2.getf(),pList)] = distCount[(int)getDistance(p.getf(),p2.getf(),pList)] + 1;
				if(distCount[1] >= NumOfEntriesPerRow){
					break;
				}
			}
			
			
			int maxSizeToTake = 0;
			int sumOfEntries =0;
			for(int index = 1; index < distCount.length; index++){
				sumOfEntries = sumOfEntries + distCount[index];
				if(sumOfEntries >= NumOfEntriesPerRow){
					maxSizeToTake = index;
					break;
				}
			}
			
			if(sumOfEntries == NumOfEntriesPerRow){
				for(int index = 1; index <= maxSizeToTake; index++){
					RowDistance = RowDistance + (distCount[index]*index);
				}
			}
			else if(sumOfEntries > NumOfEntriesPerRow){
				int counterOfEntries = 0;
				for(int index = 1; index < maxSizeToTake; index++){
					RowDistance = RowDistance + (distCount[index]*index);
					counterOfEntries = counterOfEntries + distCount[index];
				}
				int entriesLeftToObtain = NumOfEntriesPerRow - counterOfEntries;
				RowDistance = RowDistance + (entriesLeftToObtain*maxSizeToTake);
			}
			else{
				System.out.println("Error in TPD calculation");
			}
			//System.out.println("RowDistances " + RowDistances);
			geneRowDist.put(p.first.getName(),RowDistance);
			RowDistances.add(RowDistance);
		}

		int tenPercent = NumOfEntriesPerRow;
		
		List<Entry<String,Double>> geneRowDistList = new ArrayList<Entry<String,Double>>();
		
		
		Set<Entry<String,Double>> geneRowDistEntrySet = geneRowDist.entrySet();
		for(int index = 0; index < tenPercent; index++){
			Entry<String,Double> minNotInList = null;
			for(Entry<String,Double> geneRowDistEntry: geneRowDistEntrySet){
				
				if(minNotInList == null){
					
					boolean found = false;
					for(Entry<String,Double> geneRowDistEntryInList: geneRowDistList){
						if(geneRowDistEntry.getKey().equals(geneRowDistEntryInList.getKey())){
							found = true;
						}
					}
					if(!found){
						minNotInList = geneRowDistEntry;
					}
				}
				else{
					if(geneRowDistEntry.getValue() <= minNotInList.getValue()){
						boolean found = false;
						for(Entry<String,Double> geneRowDistEntryInList: geneRowDistList){
							if(geneRowDistEntry.getKey().equals(geneRowDistEntryInList.getKey())){
								found = true;
							}
						}
						if(!found){
							minNotInList = geneRowDistEntry;
						}
					}
				}
			}
			
			geneRowDistList.add(minNotInList);
			
		}
		System.out.println("TOP TEN PERCENT");
		for(int index = 0; index < tenPercent; index++){
			System.out.print(geneRowDistList.get(index).getValue() + "\t");
			try{
				outCore.write(geneRowDistList.get(index).getKey() +"\t");
				outCore.flush();
			}catch (Exception e) {
				e.printStackTrace();
			}
		}
		try{
			outCore.write("\n");
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		
		Collections.sort(RowDistances);
		//if(RowDistances.size() != listProteinIndex.size()){
			//System.out.println("Error in TPD calculation 2");
		//}
		
		System.out.print("\n ALL ROW DISTANCES");
		for(int index = 0; index < RowDistances.size(); index++){
			System.out.print(RowDistances.get(index) + "\t");
		}
		System.out.print("\n");
		
		
		
		
		for(int index = 0; index < tenPercent; index++){
			//System.out.println("RowDistance ten percent " + RowDistances.get(index));
			sumDistance = sumDistance + RowDistances.get(index); 
		}
		
		
		//System.out.println("TotalDistance " + totalDistance);

		/*Change End here*/
		
		return sumDistance;
	}
	
	private double getAverageDistance(TreeNode n1, TreeNode n2){
		double distance = 0.0;
		double pairNumber = 0;
		for(int index1: n1.getIndexes()){
			for(int index2: n2.getIndexes()){
				pairNumber++;
				distance += Dist[index1][index2];
			}
		}
		distance = distance/pairNumber;
		return distance;
	}
	
	
	private double getDistance(Protein p1, Protein p2, List<Pair<Protein,List<Protein>>> pList){
		int i = indices.get(p1.getName());
		int j = indices.get(p2.getName());
		return Dist[i][j];
	}
	
	private static Hashtable<String,String> readSeqs(BufferedReader in){
		Hashtable<String,String> protsAccessions = new Hashtable<String, String>();
		try{
			String s = in.readLine();
			while(s != null){
				String[] split = s.split("|");
				String tag = split[1]+split[2];
				String name = "";
				List<String> accessionNumbers = new ArrayList<String>();
				List<String> syns = new ArrayList<String>();
				String syn = "";
				String seq = "";
				if(tag.equalsIgnoreCase("ID")){
					for(int i = 5; i < s.length(); i++){
						if(s.charAt(i) == '_'){
							break;
						}
						else{
							name = name + s.charAt(i);
						}
					}
					syns.add(name);

					String[] splitTag = s.split("|");  
					tag = splitTag[1]+splitTag[2];
					while(!tag.equals("AC")){
						s = in.readLine();
						splitTag = s.split("|"); 
						tag = splitTag[1]+splitTag[2];
						if(tag.equals("DT")){
							break;
						}
					}
					
					if(tag.equalsIgnoreCase("AC")){
						//AC   P31946; A8K9K2; E1P616;
						String[] splitAcc = s.split("   ");
						String[] splitAccNumbers = splitAcc[1].split("; ");
						for(int i = 0; i < splitAccNumbers.length-1; i++){
							accessionNumbers.add(splitAccNumbers[i]);
						}
						accessionNumbers.add(splitAccNumbers[splitAccNumbers.length-1].split(";")[0]);
					}
					
					while(!tag.equals("GN")){
						s = in.readLine();
						splitTag = s.split("|"); 
						tag = splitTag[1]+splitTag[2];
						if(tag.equals("OS")){
							break;
						}
					}
					
					if(tag.equalsIgnoreCase("GN")){
						if(!tag.equalsIgnoreCase("OS")){
							int i = 0;
							for(i = 10; i < s.length(); i++){
								if(s.charAt(i) == ';'){
									break;
								}
								else{
									syn = syn + s.charAt(i);
								}
							}
							syns.add(syn);
							if(i != s.length()-1){
								while(!(s.charAt(i) == '=')){
									i++;
								}
								i++;
								syn = "";
								while(!(s.charAt(i) == ';')){
									if(s.charAt(i) == ','){
										syns.add(syn);
										syn = "";
										i = i + 2;
									}
									syn = syn + s.charAt(i);
									i++;
								}
								syns.add(syn);
							}
						}
												
					}
				}
				
				
				for(String syno: syns){
					for(String acc: accessionNumbers){
						protsAccessions.put(syno, acc);
					}
				}
				s = in.readLine();
				
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return protsAccessions;
	}
	
	private static Hashtable<String,String> readTremblSeqs(BufferedReader in){
		Hashtable<String,String> protsAccessions = new Hashtable<String, String>();
		try{
			String s = in.readLine();
			while(s != null){
				String[] split = s.split("|");
				String tag = split[1]+split[2];
				String name = "";
				List<String> accessionNumbers = new ArrayList<String>();
				List<String> syns = new ArrayList<String>();
				String syn = "";
				String seq = "";
				if(tag.equalsIgnoreCase("ID")){
					for(int i = 5; i < s.length(); i++){
						if(s.charAt(i) == '_'){
							break;
						}
						else{
							name = name + s.charAt(i);
						}
					}
					syns.add(name);
					String[] splitTag = s.split("|");  
					tag = splitTag[1]+splitTag[2];
					while(!tag.equals("AC")){
						s = in.readLine();
						splitTag = s.split("|"); 
						tag = splitTag[1]+splitTag[2];
						if(tag.equals("DT")){
							break;
						}
					}
					
					if(tag.equalsIgnoreCase("AC")){
						//AC   P31946; A8K9K2; E1P616;
						String[] splitAcc = s.split("   ");
						String[] splitAccNumbers = splitAcc[1].split("; ");
						for(int i = 0; i < splitAccNumbers.length-1; i++){
							accessionNumbers.add(splitAccNumbers[i]);
						}
						accessionNumbers.add(splitAccNumbers[splitAccNumbers.length-1].split(";")[0]);
					}
					
					while(!tag.equals("GN")){
						s = in.readLine();
						splitTag = s.split("|"); 
						tag = splitTag[1]+splitTag[2];
						if(tag.equals("OS")){
							break;
						}
					}
					
					if(tag.equalsIgnoreCase("GN")){
						if(!tag.equalsIgnoreCase("OS") && s.charAt(5) != 'O'){
							int i = 0;
							for(i = 10; i < s.length(); i++){
								if(s.charAt(i) == ';'){
									break;
								}
								else{
									syn = syn + s.charAt(i);
								}
							}
							syns.add(syn);
							if(i != s.length()-1){
								while(!(s.charAt(i) == '=')){
									i++;
								}
								i++;
								syn = "";
								while(!(s.charAt(i) == ';')){
									if(s.charAt(i) == ','){
										syns.add(syn);
										syn = "";
										i = i + 2;
									}
									if(i >= s.length()){
										break;
									}
									syn = syn + s.charAt(i);
									i++;
									if(i >= s.length()){
										break;
									}
								}
								syns.add(syn);
							}
						}
						
					}
				}
				
				for(String syno: syns){
					for(String acc: accessionNumbers){
						protsAccessions.put(syno, acc);
					}
				}
				s = in.readLine();
				
				
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
		return protsAccessions;
	}

	
}
