
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class AddSmallCoresToLESMON_Output {
	
	public AddSmallCoresToLESMON_Output(){
		
	}
	public void run(String folder, String resultFile, String smallCores){
		try{
			
			//BufferedReader in = new BufferedReader(new FileReader(new File( folder+ "/ComplexeMotifs_MotifSize8Biogrid5\'UTR_MaxLength500_GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To300andSimNormal10^5to1500T1.0E-4RandfalseCompleteRandfalsePvalueAssociation_SmallCore_ThresClust10-6.txt")));
			BufferedReader in = new BufferedReader(new FileReader(new File(smallCores)));
			String s = in.readLine();
			HashMap<String,List<String>> motifProteins = new HashMap<String,List<String>>();
			while(s != null){  
				String[] split = s.split("\t");
				String motif = split[0];
				List<String> genes = new ArrayList<String>();
				for(int i = 1; i < split.length; i++){
					genes.add(split[i]);
				}
				motifProteins.put(motif, genes);
				s = in.readLine();
			}
			
			
			
			//in = new BufferedReader(new FileReader(new File(folder+ "/ComplexeMotifs_MotifSize8Biogrid5\'UTR_MaxLength500__GenomeBrowser_nohub_top1Percent_22Aug13BiasedSamplingUpTo1500Gene_Sims10^6To300andSimNormal10^5to1500T1.0E-4_GoodFormat.txt")));
			in = new BufferedReader(new FileReader(new File(resultFile)));
			BufferedWriter out = new BufferedWriter(new FileWriter(new File(folder+"/Output_With_Cores.txt")));
			s = in.readLine();
			while(s != null){    
				String[] split = s.split("=");
				String motif = split[1];
				if(motifProteins.containsKey(motif)){
					while(!s.equals("====================")){
						out.write(s+"\n");
						s = in.readLine();
					}
					out.write("_________ Core ________\n");
					
					
					out.write("Proteins Subset=");
					out.flush();
					List<String> genes = motifProteins.get(motif);
					for(String g: genes){
						out.write(g+"\t");
						
					}
					out.write("\n====================\n");
					out.flush();
					
					s = in.readLine();
				}
				else{
					while(!s.equals("====================")){
						s = in.readLine();
					}
					s = in.readLine();
				}
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
}
