
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

public class Interaction {
	private String bait;
	private String prey;
	private HashSet<String> baitSyn;
	private HashSet<String> preySyn;
	private String baitSeq;
	private String preySeq;
	private String baitDataSet;
	private String preyDataSet;
	private String interactionDataset;
	
	
	public Interaction(String bait, String prey, HashSet<String> baitSyn, HashSet<String> preySyn, String baitDataSet, String preyDataSet, String interactionDataset){
		this.bait = bait;
		this.prey = prey;
		this.baitSyn = new HashSet<String>();
		this.baitSyn.addAll(baitSyn);
		this.preySyn = new HashSet<String>();
		this.preySyn.addAll(preySyn);
		this.baitDataSet = baitDataSet;
		this.preyDataSet = preyDataSet;
		this.interactionDataset = interactionDataset;
	}

	public String getBait() {
		return bait;
	}

	public String getPrey() {
		return prey;
	}

	public HashSet<String> getBaitSyn() {
		return baitSyn;
	}

	public HashSet<String> getPreySyn() {
		return preySyn;
	}

	public String getBaitSeq() {
		return baitSeq;
	}

	public String getPreySeq() {
		return preySeq;
	}

	public void setBaitSeq(String baitSeq) {
		this.baitSeq = baitSeq;
	}

	public String getBaitDataSet() {
		return baitDataSet;
	}

	public String getPreyDataSet() {
		return preyDataSet;
	}

	public String getInteractionDataset() {
		return interactionDataset;
	}

	public void setPreySeq(String preySeq) {
		this.preySeq = preySeq;
	}
	
	
}
