
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

public class ProteinPlusInfo {
	private String name;
	private HashSet<String> syns;
	private List<String> seq;
	private List<String> info;
	
	public ProteinPlusInfo(String name,HashSet<String> syns){
		this.name = name;
		this.syns = new HashSet<String>();
		this.syns.addAll(syns);
		this.seq = new ArrayList<String>();
		this.info = new ArrayList<String>();
	}

	public String getName() {
		return name;
	}

	public HashSet<String> getSyns() {
		return syns;
	}

	public List<String> getSeq() {
		return seq;
	}
	
	public List<String> getInfo() {
		return info;
	}

	public void setSeq(List<String> seq) {
		this.seq.addAll(seq);
	}
	
	public void addSeq(String seq) {
		this.seq.add(seq);
	}
	
	public void addInfo(String info) {
		this.info.add(info);
	}
	
	public boolean equals(Protein p){
		if(this.name.equalsIgnoreCase(name)){
			return true;
		}
		else{
			return false;
		}
	}
	
	
}
